	.include "drivecpu.i"
	
	.importzp part_rootdir
	.importzp dir_c1dcore	; 32-bit start of c1dcore
	.importzp dir_core		; 32-bit start of core
	.importzp dir_deep
	.importzp out_page
	.importzp outptr
	.importzp nameptr
	.importzp mem_page
	.importzp sectorptr
	.importzp tmp_page
	.importzp tmpptr
	.importzp scount
	.importzp vol_fstype
	.importzp file_length
	
ide_read_sector_2buf = $f800
fat_cdroot			 = $f803
fat_read_next_sector = $f806
fat_findfile		 = $f809
fat_loadfile		 = $f80c
mkicon				 = $f80f
	
;	.zeropage
;selected: 	 	.res 1	
;selected_max: 	.res 1	
;dirnr: 	 		.res 1	
;joyA:			.res 1
;joyB:			.res 1
;joyAT:			.res 1
;joyBT:			.res 1
;joyAC:			.res 1
;joyBC:			.res 1

	.segment "EXTCODE"
	jmp confaddon
	jmp freeze
ID:	.byte "  --C-ONE CPC ROM Builder v1.01--  28.01.2009"

;;--------------------------------------------
;config addon core
confaddon:
	lda #$10			;reset 1K100 nConfig
	sta $0480   
	
	lda	#0
	sta out_page		;0x00A00 ...
	ldax #$0A00			;select addon config
	stax outptr

	jsr fat_cdroot
	ldax #name_addon	
	jsr fat_findfile
	bcs	confsup
	
	lda #$60			;reset dma and addon nConfig
	sta $0480   
:	adc	#1
	bne	:-
	lda #$a0			;set addon nConfig 
	sta $0480
	
	jsr fat_loadfile	; config addon
	
;	samy out_page		;0x00A00 ...	fuer FPGA start 20x zuwenig 25x genug

;load rom data	
:	jsr fat_cdroot
	ldax #name_picture	
	jsr fat_findfile
	
	lda #$40			;reset DMA -> enable mdb(0) 
	sta $0480
	samy out_page		;0x00A00 ... reset ser-par converter
	
	lda #$c0			;set DMA -> enable mdb(0) 
	sta $0480
	jsr fat_loadfile	; store picture
	
;: jmp	:-
	
	
	lda #$40			;reset DMA -> enable mdb(0) start 3C25 core
	sta $0480
	samy out_page		;0x00A00 ... reset ser-par converter
	
	
;;--------------------------------------------
;config support core
confsup:
;	lda #$10			;reset 1K100 nConfig
;	sta $0480   
	jsr fat_cdroot
	
	
	ldax #name_srbf	
	jsr fat_findfile
	php	
	
	lda #$c0			;set DMA -> enable mdb(0) 
	sta $0480
	
	lda #$d0			;set DMA & 1K100 nConfig 
	sta $0480
	plp
	bcs	:+
	
;	lda #$ff
;	sta config_exist
	lda	#0
	sta out_page		;0x00600 ...
	ldax #$0600			;select config
;	ldax #$0800			;select config
	stax outptr
	jsr fat_loadfile	; config 1K100
	
;;;--------------------------------------------
;load start bin
:	jsr fat_cdroot
	lda	#8				;$80000
	sta out_page
	ldax #0000
	stax outptr
	ldax #name_start	
	jsr fat_findfile	;
	bcs	:+
	
	jsr fat_loadfile	;write data to 1K30 dram
	
;;--------------------------------------------
;load support bin
;:	lda config_exist
;	beq	:+  
:	lda #$40			;reset DMA => start Transfer
	sta $0480 
	jsr fat_cdroot
	lda	#0				
	sta out_page
	ldax #$0600			;0x00600 ...
	stax outptr
	ldax #name_srom	
	jsr fat_findfile	;
	bcs	:+
	jsr fat_loadfile	;write data to support ram
	
;;--------------------------------------------
;--------------------------------------------
;;config user core
;:	jsr fat_cdroot
;	ldax #name_urbf	
;	stax nameptr
;	jsr fat_findfile
;	bcs	@runcore
;	
;;	lda	$0403
;;	and	#$2
;;	bne	:+
;;	lda $0402			; read scancode
;;
;;	and #$7f
;;	cmp #$29			;SPACE?
;;	beq	@runcore
;	
;:	lda #$50			;reset DMA & nConfig
;	sta $0480   
;
;:	sbc	#1
;	jsr dummyrts
;	bne	:-
;	
;	lda #$90			;set nConfig 
;	sta $0480
;	lda	#0
;	sta out_page		;0x00600 ...
;	ldax #$0600			;select config
;	stax outptr
;	jsr fat_loadfile	; config 1K100
;	lda #$01			;screenmode
;	sta $0480   
;	lda #$82			;screenmode
;	sta $0480   
;	
;;--------------------------------------------
;start 1K100	
;:	lda image_exist
;	beq	:+
;	jsr	pauseimage
:
@runcore:	
	lda	#3
	sta $0403			;disable IEC
;:	lda config_exist
;	beq	:+  
;	lda #$8a			;set DMA and start support core and switch to extern screen
	lda #$c0			;set DMA and start support core and switch to extern screen
;	lda #$9e			;set DMA and start support core and switch to extern screen
	sta $0480
	
;	lda boot_exist
;	beq	freeze
;	jsr $2003
	
;	lda #$01			;screenmode
;	sta $0480   
;	lda #$82			;screenmode
;	sta $0480   
;	jmp reconfig
freeze:	
	sta $04C0			;freeze System
	
;:	beq	:-
;	bne :-

	 
;use only big letters!
name_srbf:
	.byte "SUPPORT RBF"
name_srom:
	.byte "SUPPORT BIN"
name_start:
	.byte "EMU     BIN"		;load at $80000 to use after reconfig 1K30
name_addon:
	.byte "EXTENDERRBF"
name_picture:
	.byte "ROM     RAW"

