;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                       K n  l l e r   -   K i s t e                        @dw risc_byte_write
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

relocate_start

risc_on equ 1

;todo
;- game menu
;- setup
;  - language
;  - dsk automatisch zurckschreiben an/aus


;memory map
;00000-3ffff -> Disc A
;40000-7ffff -> Disc B (geplant)
;70000-7ffff -> Zwischenspeicher fr SymbOS
;80000-8ffff -> Risccode fr Z80+6502 Emu, Keymatrix Emu
;90000-93fff -> Rom Low
;94000-9bfff -> **frei**
;9c000-9ffff -> Z80 Ram und Code(9c000-9ffff) fr FDC Emu
;a0000-affff -> zuerst BigBoot, dann SymbOS
;b0000-bffff -> CPC
;c0000-fffff -> Rom Hig 00-15

;if risc_on
risc_byte_write equ #b5ed   ;Byte schreiben -> A=Byte, C=Adr[23-16], HL=Adr[15-0]
risc_byte_read  equ #a5ed   ;Byte lesen     -> C=Adr[23-16], HL=Adr[15-0] -> A=Byte
;stam			equ #b5ed   ;Byte schreiben -> A=Byte, C=Adr[23-16], HL=Adr[15-0]
;ldam		    equ #a5ed   ;Byte lesen     -> C=Adr[23-16], HL=Adr[15-0] -> A=Byte
;else
;risc_byte_write equ #0000
;risc_byte_read  equ #0000
;endif

risc_disc_a     equ #1000   ;1024KB Speicher fr Disc A/#100
risc_disc_b     equ #2000   ;1024KB Speicher fr Disc B/#100
risc_rom_lo     equ #900    ; 16KB Speicher fr ROM LO/#100
risc_rom_hi     equ #c00    ;256KB Speicher fr ROM HI/#100
;risc_disc_a_mod equ #bfc0   ;Adresse des Flag, ob DSK A gendert wurde (Bank 9)

FDCSTAT		equ	#FC04
FDCIO		equ	#FC05
SYSIO		equ	#FC08

;==============================================================================
;### CODE-TEIL ################################################################
;==============================================================================

;### PROGRAMM-KOPF ############################################################

prgdatcod       equ 0           ;Lnge Code-Teil (Pos+Len beliebig; inklusive Kopf!)
prgdatdat       equ 2           ;Lnge Daten-Teil (innerhalb 16K Block)
prgdattra       equ 4           ;Lnge Transfer-Teil (ab #C000)
prgdatorg       equ 6           ;Original-Origin
prgdatrel       equ 8           ;Anzahl Eintrge Relocator-Tabelle
prgdatstk       equ 10          ;Lnge Stack (Transfer-Teil beginnt immer mit Stack)
prgdatcrn       equ 12          ;Lnge gecrunchte Daten
prgdatctp       equ 14          ;Crunch-Typ (0=ungepackt, 1=SymbOS, 2=eigene Routine)
prgdatnam       equ 15          ;Programm-Name (32+1[0] Zeichen)
prgdatidn       equ 48          ;"SymExe10"
prgdatres       equ 56          ;*reserviert* (34 bytes)
prgdatism       equ 90          ;Icon (klein)
prgdatibg       equ 109         ;Icon (gross)
prgdatlen       equ 256         ;Datensatzlnge

prgpstdat       equ 6           ;Adresse Daten-Teil
prgpsttra       equ 8           ;Adresse Transfer-Teil
prgpstspz       equ 10          ;zustzliche Prozessnummern (4*1)
prgpstbnk       equ 14          ;Bank (1-8)
prgpstmem       equ 48          ;zustzliche Memory-Bereiche (8*5)
prgpstnum       equ 88          ;Programm-Nummer
prgpstprz       equ 89          ;Prozess-Nummer

prgcodbeg   dw prgdatbeg-prgcodbeg  ;Lnge Code-Teil
            dw prgtrnbeg-prgdatbeg  ;Lnge Daten-Teil
            dw prgtrnend-prgtrnbeg  ;Lnge Transfer-Teil
prgdatadr   dw #1000                ;Original-Origin                    POST Adresse Daten-Teil
prgtrnadr   dw relocate_count       ;Anzahl Eintrge Relocator-Tabelle  POST Adresse Transfer-Teil
prgprztab   dw prgstk-prgtrnbeg     ;Lnge Stack                        POST Tabelle Prozesse
            dw 0                    ;Lnge gecrunchte Daten
prgbnknum   db 0                    ;Crunch-Typ                         POST Bank-Nummer
            db "R-BOX 880":ds 32-9:db 0   ;Name
prgmemtab   db "SymExe10"           ;SymbOS-EXE-Kennung                 POST Tabelle Speicherbereiche
            dw lodmax               ;zustzlicher Code-Speicher
            dw cfgmax               ;zustzlicher Data-Speicher
            dw 0                    ;zustzlicher Transfer-Speicher
            ds 28                   ;*reserviert*
prgicnsml   db 2,8,8:db #77,#00:db #8F,#CC:db #9F,#FF:db #AF,#1F:db #AF,#1F:db #CF,#2E:db #CF,#2E:db #77,#CC
prgicnbig   db 6,24,24,#00,#00,#00,#00,#00,#00,#33,#FE,#00,#00,#00,#00,#47,#1F,#80,#FF,#CC,#00,#8F,#0F,#FF,#0F,#6C,#00,#8F,#0F,#0F,#0F,#6C,#00,#8F,#0F,#0F,#0F,#7D,#EE,#8F,#3E,#E3,#1F,#EF,#3E,#8F,#4B,#16,#EF,#0F,#6C,#8F,#82,#0A,#87
            db #0F,#6C,#9F,#0D,#05,#4F,#0F,#C8,#9E,#0A,#0A,#4B,#0F,#C8,#9E,#04,#05,#43,#1F,#80,#9E,#08,#02,#4B,#1F,#80,#9F,#0C,#05,#4F,#3E,#00,#9F,#82,#0A,#87,#3E,#00,#9F,#4B,#16,#C3,#6C,#00,#AF,#3E,#E3,#E7,#6C,#00,#EF,#0F,#0F,#F7
            db #C0,#00,#CF,#0F,#7F,#FB,#88,#00,#47,#7F,#F8,#B1,#CC,#00,#77,#F8,#80,#10,#EE,#00,#30,#80,#00,#00,#F7,#00,#00,#00,#00,#00,#72,#80,#00,#00,#00,#00,#30,#00


;### PRGPRZ -> Programm-Prozess
dskprzn     db 2
sysprzn     db 3
windatprz   equ 3   ;Prozenummer
windatsup   equ 51  ;Nummer des Superfensters+1 oder 0
prgwin      db 0    ;Nummer des Haupt-Fensters
prgwinrun   db 0    ;Nummer des Run-Fensters

prgprz  ld a,(prgprzn)
        ld (prgwindat+windatprz),a
        ld (prgarudat+windatprz),a

fdcinit:
;	ld	a,'H'
;	call	txtchar
;	ld	a,'a'
;	call	txtchar
;	ld	a,'l'
;	call	txtchar
;	ld	a,'l'
;	call	txtchar
;	ld	a,'o'
;	call	txtchar
;	ld	a,' '
;	call	txtchar
			sub		a,a
			ld		(dskwritestat),a
			ld		a,#80				;Anfangswert
			ld		(mainstatus),a		;Mainstatus FDC
			ld		a,#ff
			ld		(commandcount),a	;commandcount,0ffh
			ld		hl,#0001
			ld		(bytecount),hl		;bytecount,00001h

			ld		a,#81
;			ld		a,#80
			ld		bc,FDCSTAT			;starte CPU
			out		(c),a

;        call riscin
        call cfgrun

        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,prgwindat
        call msgsnd             ;Fenster aufbauen
prgprz1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        jp z,prgend             ;kein Speicher fr Fenster -> Proze beenden
        cp MSR_DSK_WOPNOK
        jr nz,prgprz1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (prgwin),a           ;Fenster wurde geffnet -> Nummer merken

        jp syscpc

prgprz0 call msgget
        jr nc,prgprz0
        cp MSR_DSK_CFOCUS       ;*** Focus auf anderes Objekt
        jr nz,prgprz3
        ld a,13+1               ;Focus neu setzen
        ld (prgwingrpb+14),a
        ld a,27+1
        ld (prgwingrpc+14),a
        jr prgprz0
prgprz3 cp MSR_SYS_SELOPN       ;*** Browse-Fenster wurde geschlossen
        jp z,prgbrc
        cp MSR_DSK_WCLICK       ;*** Fenster-Aktion wurde geklickt
        jr nz,prgprz0
        ld a,(prgwin)
        cp (iy+1)
        jr nz,prgprz0
        ld a,(iy+2)             ;*** HAUPT-FENSTER
        cp DSK_ACT_CLOSE        ;*** Close wurde geklickt
        jp z,prgend
        cp DSK_ACT_KEY          ;*** Taste wurde gedrckt
        jr z,prgkey
        cp DSK_ACT_CONTENT      ;*** Inhalt wurde geklickt
        jr nz,prgprz0
prgprz2 ld l,(iy+8)
        ld h,(iy+9)
        ld a,h
        or l
        jr z,prgprz0
        ld a,(iy+3)             ;A=Klick-Typ (0/1/2=Maus links/rechts/doppelt, 7=Tastatur)
        jp (hl)

;### PRGKEY -> Taste auswerten
prgkeyt dw prgkeya,prgkeyb,prgkeyc,prgkeyd,prgkeye
prgkeya db 3                ;Core
        db 138:dw ctllft
        db 139:dw ctlrgt
        db 13: dw ctlret
prgkeyb db 2                ;CPC Rom
        db 27: dw syscor
        db 13: dw sysdsk
prgkeyc db 4                ;CPC Disc
        db 27: dw syscpc
        db 13: dw ctldrt
        db 138:dw ctldlf
        db 139:dw ctldrg
prgkeyd db 2                ;C64 Disc
        db 27: dw syscor
        db 13: dw syscru
prgkeye db 2                ;Game
        db 27: dw syscor
        db 13: dw sysgru

prgkey  ld a,(sysmod)
        add a
        ld l,a
        ld h,0
        ld bc,prgkeyt
        add hl,bc
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld a,(hl)
        or a
        jp z,prgprz0
        ld b,a
        inc hl
        ld de,3
        ld a,(iy+4)
prgkey1 ld c,(hl)
        cp c
        jr z,prgkey2
        add hl,de
        djnz prgkey1
        jp prgprz0
prgkey2 inc hl
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld a,7
        jp (hl)

;### PRGEND -> Programm beenden
prgend  ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        ld (iy+0),MSC_SYS_PRGEND
        ld a,(prgcodbeg+prgpstnum)
        ld (iy+1),a
        rst #10
prgend0 rst #30
        jr prgend0

;### PRGINF -> Info-Fenster anzeigen
prginf  ld hl,prgmsginf         ;*** Info-Fenster
        ld b,1+128
        call prginf0
        jp prgprz0
prginf0 ld (prgmsgb+1),hl
        ld a,(prgbnknum)
        ld c,a
        ld (prgmsgb+3),bc
        ld a,MSC_SYS_SYSWRN
        ld (prgmsgb),a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        rst #10
        ret


;==============================================================================
;### SUB-ROUTINEN #############################################################
;==============================================================================

;### MSGGET -> Message fr Programm abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgget  ld a,(prgprzn)
        db #dd:ld l,a           ;IXL=Rechner-Proze-Nummer
        db #dd:ld h,-1
        ld iy,prgmsgb           ;IY=Messagebuffer
msgget1 rst #08                 ;Message holen -> IXL=Status, IXH=Absender-Proze
        or a
        db #dd:dec l
        ret nz
        ld iy,prgmsgb
        ld a,(iy+0)
        or a
        jp z,prgend
        scf
        ret

;### MSGDSK -> Message fr Programm von Deskzop-Prozess abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgdsk  call msgget
        jr nc,msgdsk            ;keine Message
        ld a,(dskprzn)
        db #dd:cp h
        jr nz,msgdsk            ;Message von anderem als Desktop-Proze -> ignorieren
        ld a,(prgmsgb)
        ret

;### MSGSND -> Message an Desktop-Prozess senden
;### Eingabe    C=Kommando, B/E/D/L/H=Parameter1/2/3/4/5
msgsnd0 ld a,(prgwin)
        ld b,a
msgsnd2 ld c,MSC_DSK_WININH
msgsnd  ld a,(dskprzn)
msgsnd1 db #dd:ld h,a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),b
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        rst #10
        ret

;### SYSCLL -> Filemanager-Funktion aufrufen
;### Eingabe    (SP)=Modul/Funktion, AF,BC,DE,HL,IX,IY=Register
;### Ausgabe    AF,BC,DE,HL,IX,IY=Register
sysclln db 0
syscll  ld (prgmsgb+04),bc      ;Register in Message-Buffer kopieren
        ld (prgmsgb+06),de
        ld (prgmsgb+08),hl
        ld (prgmsgb+10),ix
        ld (prgmsgb+12),iy
        push af
        pop hl
        ld (prgmsgb+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (prgmsgb+00),de      ;Modul und Funktion in Message-Buffer kopieren
        ld a,e
        ld (sysclln),a
        ld iy,prgmsgb
        ld a,(prgprzn)          ;Desktop und System-Prozessnummer holen
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        rst #10                 ;Message senden
syscll1 rst #30
        ld iy,prgmsgb
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        rst #18                 ;auf Antwort warten
        db #dd:dec l
        jr nz,syscll1
        ld a,(prgmsgb)
        sub 128
        ld e,a
        ld a,(sysclln)
        cp e
        jr nz,syscll1
        ld hl,(prgmsgb+02)      ;Register aus Message-Buffer holen
        push hl
        pop af
        ld bc,(prgmsgb+04)
        ld de,(prgmsgb+06)
        ld hl,(prgmsgb+08)
        ld ix,(prgmsgb+10)
        ld iy,(prgmsgb+12)
        ret

;### STRINP -> Initialisiert Textinput (Lnge eintragen, Cursor ans Ende)
;### Eingabe    IX=Control
;### Ausgabe    HL=Stringende (0), BC=Lnge (maximal 255)
;### Verndert  AF
strinp  ld l,(ix+0)
        ld h,(ix+1)
        call strlen
        ld (ix+8),c
        ld (ix+4),c
        xor a
        ld (ix+2),a
        ld (ix+6),a
        ret

;### STRLEN -> Ermittelt Lnge eines Strings
;### Eingabe    HL=String
;### Ausgabe    HL=Stringende (0), BC=Lnge (maximal 255)
;### Verndert  -
strlen  push af
        xor a
        ld bc,255
        cpir
        ld a,254
        sub c
        ld c,a
        dec hl
        pop af
        ret

;### STRFND -> Sucht String (case sensitiv)
;### Eingabe    HL=String (mit 0 terminiert), DE=Speicheranfang (,BC=Speichergre)
;### Ausgabe    CF=0 -> HL=Adresse hinter String, CF=1 -> String nicht gefunden
strfnd  ld bc,16384
strfnd0 ex de,hl
strfnd1 ld a,(de)
        cpir
        scf
        ret nz
        push de
        push hl
        dec hl
strfnd2 inc de
        inc hl
        ld a,(de)
        or a
        jr z,strfnd3
        cp (hl)
        jr z,strfnd2
        pop hl
        pop de
        jr strfnd1
strfnd3 pop de
        pop de
        ret

;### CLCDEZ -> Rechnet Byte in zwei Dezimalziffern um
;### Eingabe    A=Wert
;### Ausgabe    L=10er-Ascii-Ziffer, H=1er-Ascii-Ziffer
;### Veraendert AF
clcdez  ld l,0
clcdez1 sub 10
        jr c,clcdez2
        inc l
        jr clcdez1
clcdez2 add "0"+10
        ld h,a
        ld a,"0"
        add l
        ld l,a
        ret

;### CLCD16 -> Dividiert zwei Werte (16bit)
;### Eingabe    BC=Wert1, DE=Wert2
;### Ausgabe    HL=Wert1/Wert2, DE=Wert1 MOD Wert2
;### Veraendert AF,BC,DE
clcd16  ld a,e
        or d
        ld hl,0
        ret z
        ld a,b
        ld b,16
clcd161 rl c
        rla
        rl l
        rl h
        sbc hl,de
        jr nc,clcd162
        add hl,de
clcd162 ccf
        djnz clcd161
        ex de,hl
        rl c
        rla
        ld h,a
        ld l,c
        ret


;==============================================================================
;### CONFIG-INTERPRETER #######################################################
;==============================================================================

;### CFGBLK -> Sucht Block innerhalb Config
;### Eingabe    HL=Bezeichner (inklusive []+0, case sensitiv!)
;### Ausgabe    CF=0 -> HL=Adresse ab Block Start, BC=verbleibende Lnge, CF=1 -> Block nicht vorhanden
cfgblk  ld de,cfgtxt
        jp strfnd

;### CFGENT -> Sucht nchsten Eintrag
;### Eingabe    HL=Adresse im Block
;### Ausgabe    CF=0 -> HL=auf LF vor erster Zeile, CF=1 -> kein weiterer Eintrag vorhanden
cfgent0 db 13,"[",0
cfgent1 db 13,"[entry]",0
cfgent  push hl
        ex de,hl
        ld hl,cfgent0
        call strfnd
        pop de
        ret c
        push hl
        ld hl,cfgent1
        call strfnd         ;HL=hinter [entry]
        pop de              ;DE=hinter [
        ret c
        push hl
        ld bc,-6
        add hl,bc
        or a
        sbc hl,de
        pop hl
        ret z
        scf
        ret

;### CFGLIN -> Sucht Zeile innerhalb Eintrag
;### Eingabe    DE=LF vor erster Zeile, HL=Zeile (inklusive 13+name+"=")
;### Ausgabe    CF=0 -> HL=erstes Zeichen hinter "=", CF=1 -> Zeile nicht gefunden
cfglin  push de
        ld bc,1024
        call strfnd0
        pop de
        ret c
        push hl
        ld hl,cfgent0
        call strfnd
        pop de
        ret c
        sbc hl,de
        ret c
        ex de,hl
        ret

;### CFGCNV -> Konvertiert Config-Zeile (\ und 13 -> 0)
;### Eingabe    HL=Zeile
cfgcnv  ld a,(hl)
        cp "\"
        jr nz,cfgcnv2
        ld (hl),0
cfgcnv1 inc hl
        jr cfgcnv
cfgcnv2 cp 13
        jr nz,cfgcnv1
        ld (hl),0
        ret

;### CFGCPC -> Liest CPC-ROMs aus der Configuration
cfgcpci db "[amstrad cpc rom]",0
cfgcpcn db 13,"name=",0
cfgcpcd db 13,"description=",0
cfgcpcr db 13,"romXX=",0
cfgcpca db 0
cfgcpce dw 0

cfgcpc  xor a
        ld (cfgcpca),a
        ld hl,romnam
        ld de,romnam+1
        ld (hl),0
        ld bc,20*17*2-1
        ldir
        ld hl,cfgcpci
        call cfgblk     ;HL=Block
        jr c,cfgcpc4
cfgcpc1 call cfgent     ;HL=Eintrag
        jr c,cfgcpc4
        ld (cfgcpce),hl
        ld hl,cfgcpcn       ;*** Name
        call cfgcpc2
        jr c,cfgcpc3
        ld bc,syscpclst+2
        add hl,hl
        add hl,bc
        ld (hl),e
        inc hl
        ld (hl),d
        ld hl,cfgcpcd       ;*** Description
        call cfgcpc2
        jr c,cfgcpc3
        ld bc,romdsct
        add hl,bc
        ld (hl),e
        inc hl
        ld (hl),d
        ld b,17             ;*** ROMs
        ld hl,"o"*256+"l"
cfgcpc7 push bc
        ld (cfgcpcr+4),hl
        ld hl,cfgcpcr
        call cfgcpc2
        pop bc
        jr c,cfgcpc8
        push bc
        ld c,l
        ld b,h
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,bc
        ld bc,romnam
        add hl,bc
        pop bc
        ld a,17
        sub b
        add a
        add l
        ld l,a
        ld a,h
        adc 0
        ld h,a
        ld (hl),e
        inc hl
        ld (hl),d
cfgcpc8 ld a,17
        sub b
        call clcdez
        djnz cfgcpc7
        ld hl,cfgcpca
        inc (hl)
        ld a,(hl)
        cp 20
cfgcpc3 ld hl,(cfgcpce)
        jr c,cfgcpc1
cfgcpc4 ld a,(cfgcpca)
        or a
        jr nz,cfgcpc5
        ld hl,syscpcdsca    ;*** Dummy-Config setzen
        ld (romdsct),hl
        ld hl,syscpctxta
        ld (syscpclst+2),hl
        ld hl,romnamd
        ld de,romnam
        ld bc,18
        ldir
        inc a
cfgcpc5 ld (syscpcobj1),a
        ret
cfgcpc2 ld de,(cfgcpce)
        call cfglin
        jr c,cfgcpc6
        push hl
        call cfgcnv
        pop de
        or a
cfgcpc6 push af
        ld a,(cfgcpca)
        add a
        ld l,a
        ld h,0
        pop af
        ret

;### CFGDSK -> Liest CPC-DSK-Favouriten aus der Configuration
cfgdski db "[amstrad cpc dsk]",0
cfgdska db 13,"disca=",0
cfgdskb db 13,"discb=",0

cfgdsk  xor a
        ld (cfgcpca),a
        ld hl,cfgdski
        call cfgblk     ;HL=Block
        jr c,cfgdsk4
cfgdsk1 call cfgent     ;HL=Eintrag
        jr c,cfgdsk4
        ld (cfgcpce),hl
        ld hl,cfgcpcn   ;Name
        call cfgcpc2
        jr c,cfgdsk3
        ld bc,sysdsklst+2
        add hl,hl
        add hl,bc
        ld (hl),e
        inc hl
        ld (hl),d
        ld hl,cfgcpcd   ;Description
        call cfgcpc2
        jr c,cfgdsk3
        ld bc,dskdsct
        call cfgdsk2
        ld hl,cfgdska   ;Drive A
        call cfgcpc2
        ld bc,dskdsct+2
        call cfgdsk2
        ld hl,cfgdskb   ;Drive B
        call cfgcpc2
        ld bc,dskdsct+4
        call cfgdsk2
        ld hl,cfgcpca
        inc (hl)
        ld a,(hl)
        cp 50
cfgdsk3 ld hl,(cfgcpce)
        jr c,cfgdsk1
cfgdsk4 ld a,(cfgcpca)
        or a
        jr nz,cfgdsk5
        ld hl,sysdskdsca
        ld (dskdsct),hl
        ld hl,sysdskdsca0
        ld (dskdsct+2),hl
        ld hl,sysdskdsca1
        ld (dskdsct+4),hl
        ld hl,sysdsktxta
        ld (sysdsklst+2),hl
        inc a
cfgdsk5 ld (sysdskobj9),a
        ret
cfgdsk2 jr nc,cfgdsk6
        ld de,0
cfgdsk6 add hl,hl
        add hl,hl
        add hl,bc
        ld (hl),e
        inc hl
        ld (hl),d
        ret

;### CFGINI -> Generiert Config-Pfad und ldt Config
cfgnam  db "appretro.ini",0:cfgnam0
cfgpth  dw 0

cfgini  ld hl,(prgcodbeg)
        ld de,prgcodbeg
        dec h
        add hl,de           ;HL=CodeEnde=Pfad
        ld (cfgpth),hl
        ld e,l
        ld d,h              ;DE=HL
        ld b,255
cfgini1 ld a,(hl)           ;Pfad-Ende suchen
        or a
        jr z,cfgini2
        inc hl
        djnz cfgini1
        jr cfgini4
        ld a,255
        sub b
        jr z,cfgini4
        ld b,a
cfgini2 dec hl              ;Filename-Anfang suchen
        ld a,(hl)
        cp "/"
        jr z,cfgini3
        cp "\"
        jr z,cfgini3
        cp ":"
        jr z,cfgini3
        djnz cfgini2
        jr cfgini4
cfgini3 inc hl
        ex de,hl
cfgini4 ld hl,cfgnam        ;Programm-Filename mit Config-Filename ersetzen
        ld bc,cfgnam0-cfgnam
        ldir
        ld hl,(cfgpth)      ;Config-File ffnen
        ld a,(prgbnknum)
        db #dd:ld h,a
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN
        ret c
        ld de,(prgbnknum)   ;Config laden
        ld hl,cfgtxt
        ld bc,cfgmax
        push af
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        pop af              ;Config-File schlieen
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        ret

;### CFGRUN -> Ldt und initialisiert Config
cfgmax  equ 10000

cfgrun  call cfgini
        ld hl,cfgtxt
        ld bc,cfgmax
cfgrun1 ld a,10
        cp (hl)
        jr nz,cfgrun2
        ld (hl),13
cfgrun2 inc hl
        dec bc
        ld a,c
        or b
        jr nz,cfgrun1
        call cfgcpc
        jp cfgdsk


;==============================================================================
;### FILE-BROWSER #############################################################
;==============================================================================

;### PRGBRO -> Browse-Fenster ffnen
;### Eingabe    A=Typ (1=CPC DSK A, 2=CPC DSK B), HL=Maske/Pfad
prgbron db 0
prgbro  ld e,a
        ld a,(prgbron)
        or a
        ret nz
        ld a,e
        ld (prgbron),a
        ld (prgmsgb+8),hl
        ld hl,(prgbnknum)
        ld h,8
        ld (prgmsgb+6),hl
        ld hl,1000
        ld (prgmsgb+10),hl
        ld hl,16384
        ld (prgmsgb+12),hl
        ld l,MSC_SYS_SELOPN
        ld (prgmsgb),hl
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        rst #10
        ret

;### PRGBRC -> Browse-Fenster schlieen
;### Eingabe    P1=Typ (0=Ok, 1=Abbruch, 2=FileAuswahl bereits in Benutzung, 3=kein Speicher frei, 4=kein Fenster frei), P2=PfadLnge
prgbrc  ld a,(prgmsgb+1)
        inc a
        jr nz,prgbrc0
        ld a,(prgmsgb+2)
        ld (prgwindat+windatsup),a
        jp prgprz0
prgbrc0 ld hl,prgbron
        ld e,(hl)
        ld (hl),0
        dec a
        jp nz,prgprz0
        ld ix,sysdskobj3
        call strinp
        ld ix,sysdskobj4
        call strinp
        jp dskfav3


;==============================================================================
;### CONTROL ##################################################################
;==============================================================================

ctlpos  db 1    ;0=CPC, 1=C64, 2=Game

;### CTLLFT -> Core-Cursor links
ctllft  call ctllft0
        ld a,(ctlpos)
        dec a
        cp -1
        jr nz,ctllft1
        inc a
ctllft1 ld (ctlpos),a
        ld bc,106
        ld hl,2-106
ctllft2 add hl,bc
        sub 1
        jr nc,ctllft2
        ld (prgwinobj1+22),hl
        ld de,256*09+256-2
        call msgsnd0
        jp prgprz0
ctllft0 ld hl,(prgwinobj1+22)
        ld (prgwinobj1+6),hl
        ret

;### CTLRGT -> Core-Cursor rechts
ctlrgt  call ctllft0
        ld a,(ctlpos)
        inc a
        cp 3
        jr nz,ctllft1
        dec a
        jr ctllft1

;### CTLRET -> Return
ctlret  ld a,(ctlpos)
        cp 1
        jp c,sysc64
        jp z,syscpc
        jp sysgam

;### CTLROM -> Rom-Liste angeklickt
ctlromo db -1
ctlrom  cp 2
        jp z,sysdsk
        ld a,(syscpcobj1+12)
        ld hl,ctlromo
        cp (hl)
        jp z,prgprz0
        ld (hl),a
        call romdsc
        call romdsp
        jp prgprz0

;### CTLDSK -> DSK-Liste angeklickt
ctldsko db -1
ctldsk  cp 2
        jp z,dskfav
        ld a,(sysdskobj9+12)
        ld hl,ctldsko
        cp (hl)
        jp z,prgprz0
        ld (hl),a
        call dskdsc
        call dskdsp
        jp prgprz0

;### CTLRLF -> Disk-Cursor links
ctldps  db 1

ctldlf  call ctldlf0
        ld a,(ctldps)
        dec a
        cp -1
        jp z,prgprz0
ctldlf1 call ctldlfx
        jp prgprz0
ctldlfx ld (ctldps),a
        ld e,a
        or a
        ld hl,25*256+64
        jr nz,ctldlf3
        ld hl,35*256+41
ctldlf3 ld a,h
        ld (prgwingrpc),a
        ld a,l
        ld (prgwinobj3+2),a
        ld a,2+4+128
        ld (sysdskobj5+2),a
        ld (sysdskobj6+2),a
        ld (sysdskobj7+2),a
        ld (sysdskobj8+2),a
        ld a,e
        add a:add a
        ld l,a
        ld h,0
        ld bc,sysdskobj5+2
        add hl,bc
        ld (hl),3+0+128
        ld a,e
        ld bc,78
        ld hl,4-78
ctldlf2 add hl,bc
        sub 1
        jr nc,ctldlf2
        ld (prgwinobj2+22),hl
        push de
        ld hl,256*89+0
        ld de,320
        ld a,59
        call romdsp0
        pop de
        inc e
        dec e
        ld de,256*19+256-6
        jr nz,ctldlf4
        ld e,256-16
ctldlf4 call msgsnd0
        rst #30
        ret
ctldlf0 ld hl,(prgwinobj2+22)
        ld (prgwinobj2+6),hl
        ret

;### CTLDRG -> Disk-Cursor rechts
ctldrg  call ctldlf0
        ld a,(ctldps)
        inc a
        cp 4
        jr nz,ctldlf1
        jp prgprz0

;### CTLDRT -> Disk-Return
ctldrt  ld a,(ctldps)
        cp 1
        jp c,dskfav
        jp z,dskbra
        cp 3
        jp c,dskbrb
        jp sysaru


;==============================================================================
;### CPC ROM AUSWAHL ##########################################################
;==============================================================================

;### ROMDSC -> Updated die Rom-Beschreibung
romdsct dw syscpcdsca:ds 19*2
romdscg dw sprsys464,sprsys664,sprsys128
romnam  ds 20*17*2     ;Lower-Rom + 16 x Upper-Rom
romnamd dw syscpcroml,syscpcrom0,0,0,0,0,0,0,syscpcrom7

romdsc  ld a,(syscpcobj1+12)
        add a
        ld l,a
        ld h,0
        ld bc,romdsct
        add hl,bc
        ld e,(hl)
        inc hl
        ld d,(hl)
        ld a,(de)
        sub "0"
        add a
        ld l,a
        ld h,0
        ld bc,romdscg
        add hl,bc
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld (prgwinobjb1),hl
        inc de
        inc de
        ld b,6
        ld ix,syscpcdsc0
romdsc0 ex de,hl
        ld de,4
        xor a
romdsc1 ld (ix+0),l
        ld (ix+1),h
        add ix,de
        dec b
        ret z
romdsc2 cp (hl)
        inc hl
        jr nz,romdsc2
        jr romdsc1

;### ROMDSP -> Zeigt die Rom-Beschreibung an
romdsp  ld hl,256*54+191
        ld de,124
        ld a,6*8
        call romdsp0
        ld de,16*256+256-7
        jp msgsnd0
romdsp0 ld iy,prgmsgb
        ld (iy+6),h
        ld h,0
        ld (iy+7),h
        ld (iy+8),e
        ld (iy+9),d
        ld (iy+10),a
        ld (iy+11),h
        ld e,h
        ld a,(prgwin)
        ld b,a
        ld c,MSC_DSK_WINPIN
        jp msgsnd


;==============================================================================
;### CPC-DSK-AUSWAHL ##########################################################
;==============================================================================

;### DSKRUN -> Startet Disk
dskrun  call ctldlf0
        ld a,3
        call ctldlfx
        jp sysaru

;### DSKFAV -> Aktiviert Favourite
dskfav  ld hl,(dskdscz+0)
        ld ix,sysdskobj3
        call dskfav1
        ld hl,(dskdscz+2)
        ld ix,sysdskobj4
        call dskfav1
dskfav3 ld de,256*17+256-2
        call msgsnd0
        jp prgprz0
dskfav1 ld e,(ix+0)
        ld d,(ix+1)
        ld a,l
        or h
        ld (de),a
        jp z,strinp
dskfav2 ld a,(hl)
        ldi
        or a
        jr nz,dskfav2
        jp strinp
dskfav0 call ctldlf0
        xor a
        call ctldlfx
        jp prgprz0

;### DSKBRA -> Auswahl fr Disk Drive A
dskbra0 call ctldlf0
        ld a,1
        call ctldlfx
dskbra  ld hl,sysdskinp3a
        ld a,1
        call prgbro
        jp prgprz0

;### DSKBRB -> Auswahl fr Disk Drive B
dskbrb0 call ctldlf0
        ld a,2
        call ctldlfx
dskbrb  ld hl,sysdskinp4a
        ld a,2
        call prgbro
        jp prgprz0

;### DSKDSC -> Updated die DSK-Beschreibung
dskdsct dw sysdskdsca,sysdskdsca0,sysdskdsca1,0:ds 49*8
dskdscz dw 0,0
dskdsc  ld a,(sysdskobj9+12)
        ld l,a
        ld h,0
        add hl,hl
        add hl,hl
        add hl,hl
        ld bc,dskdsct
        add hl,bc
        ld e,(hl):inc hl:ld d,(hl):inc hl
        ld c,(hl):inc hl:ld b,(hl):inc hl
        ld (dskdscz+0),bc
        ld c,(hl):inc hl:ld b,(hl)
        ld (dskdscz+2),bc
        ld ix,sysdskdsc0
        ld b,5
        jp romdsc0

;### DSKDSP -> Zeigt die DSK-Beschreibung an
dskdsp  ld hl,256*99+191
        ld de,124
        ld a,48
        call romdsp0
        ld de,30*256+256-6
        jp msgsnd0


;==============================================================================
;### SYSTEM-AUSWAHL ###########################################################
;==============================================================================

sysmod  db 0    ;0=Core-Wahl, 1=CPC-Config-Wahl, 2=CPC-Disc-Wahl, 3=C64-Disc-Wahl, 4=Game-Wahl

;### SYSCOR -> Core-Auswahl starten
syscor  xor a
        ld hl,prgwingrpa
        ld de,256*9+256-9
syscor0 call syscor1
        jp prgprz0
syscor1 ld (sysmod),a
        ld (prgwindat1),hl
        push de
        ld hl,256*39+0
        ld de,320
        ld a,110
        call romdsp0
        pop de
        call msgsnd0
        ld e,8
        jp msgsnd0

;### SYSCPC -> CPC-Rom-Auswahl starten
syscpc  call romdsc
        ld a,1
        ld hl,prgwingrpb
        ld de,256*10+256-13
        jr syscor0

;### SYSDSK -> CPC-Disc-Auswahl starten
sysdsk  call dskdsc
        ld a,(syscpcobj1+12)
        add a
        add a
        ld l,a
        ld h,0
        ld bc,syscpclst+2
        add hl,bc
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld (sysselobjc),hl
        ld hl,prgwingrpc
        ld de,256*10+256-15
        ld a,(ctldps)
        or a
        ld a,2
        jr nz,syscor0
        ld e,256-15
        call syscor1
        ld de,256*25+256-10
        call msgsnd0
        jp prgprz0

;### SYSC64 -> C64-Disc-Auswahl starten
sysc64  ld a,3
        ld hl,prgwingrpd
        ld e,-1
        jp syscor0

;### SYSCRU -> C64-Disc-Start
syscru  ;...
        jp prgprz0

;### SYSGAN -> Game-Auswahl starten
sysgam  ld a,4
        ld hl,prgwingrpe
        ld e,-1
        jp syscor0

;### SYSGRU -> Game-Start
sysgru  ;...
        jp prgprz0

;### SYSARU -> CPC-Disc-Start
sysarur db -1   ;aktuell geladene Rom-Konfig
sysaruc ds 2    ;Flags, ob discA/B gendert wurden
sysarul ds 8    ;Lngen der DSKs
sysarua ds 256  ;Pfad von DSK A
sysarub ds 256  ;Pfad von DSK B
sysarum db -1

sysaru  call sysaruf
        jp c,prgprz0

        ld a,(syscpcobj1+12)    ;*** ROMs laden
        ld hl,sysarur
        cp (hl)
        jr z,sysaru7
        ld (hl),a
        add a
        ld l,a
        
        ld	a,#80				;*** cpc reset
        ld bc,SYSIO   
        out (c),a         
        
        
        ld h,0
        ld c,l
        ld b,h
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,bc
        ld bc,romnam
        add hl,bc
        ld de,risc_rom_lo
        ld b,17
sysaru4 push hl
        push bc
        ld c,(hl)
        inc hl
        ld b,(hl)
        ld a,c
        or b
        ld a,d
        ld d,e
        ld e,0
        jp z,sysarui
        ld l,c              ;Rom vorhanden -> laden
        ld h,b
        ld c,0
        call imglod
        jr sysaru5
sysarui ld hl,sysarum       ;Rom nicht vorhanden -> lschen
        ld bc,1
        call riscwr
sysaru5 pop bc
        ld a,17
        sub b               ;A=0-16
        add a:add a:add a
        ld c,a
        push bc
        cp 16*8
        jr z,sysaru6
        add 8
        add a
        dec a
        ld (16*0+prgaruobj0+5),a
        ld e,5
        call imglod9
sysaru6 pop bc
        ld a,c
        ld l,a
        ld h,0
        add hl,hl
        add hl,hl
        add hl,hl
        ld de,risc_rom_hi
        add hl,de
        ex de,hl
        pop hl
        inc hl
        inc hl
        djnz sysaru4
sysaru7 ld a,255
        ld (16*0+prgaruobj0+5),a
        ld e,5
        call imglod9

        ld hl,sysdskinp3        ;*** Disc A laden
        ld de,sysarua
        ld c,6
        ld ix,16*1+prgaruobj0+5
        ld iy,risc_disc_a
        call sysaru2
        jr nc,sysarud
        ld hl,imglodsizf
        ld de,sysarul+0
        ld bc,4
        ldir

sysarud ld hl,sysdskinp4        ;*** Disc B laden
        ld de,sysarub
        ld c,7
        ld ix,16*2+prgaruobj0+5
        ld iy,risc_disc_b
        call sysaru2
        jr nc,sysarue
        ld hl,imglodsizf
        ld de,sysarul+4
        ld bc,4
        ldir

sysarue ld a,(prgwinrun)        ;*** Fenster schlieen
        ld b,a
        ld c,MSC_DSK_WINCLS
        call msgsnd

		call riscgo             ;*** CPC starten

        ld	hl,dskwritestat     ;*** Test, ob DSK(s) gendert
        ld a,(hl)
        or	a
        jp z,prgprz0

        ld a,64                 ;*** DSK(s) zurckschreiben
        ld (prgaruobj1+2),a
        ld (prgaruobj0+2),a
        ld hl,sysarutxt1b
        ld (sysarudsc1),hl
        call sysaruf
        jr c,sysarug

		ld	hl,dskwritestat     ;*** Test, ob DSK A gendert
        ld a,(hl)
        and #0f
        jr z,sysaruh
        xor (hl)
        ld (hl),a

        ld hl,sysarua           ;*** Drive A speichern
        ld de,risc_disc_a
        ld a,d
        ld d,e
        ld e,0
        ld c,6
        ld ix,16*1+prgaruobj0+5
        ld iy,sysarul+0
        call imgsav
        
        
sysaruh ld	hl,dskwritestat     ;*** Test, ob DSK B gendert
        ld a,(hl)
        and #f0
        jr z,sysaruj
        xor (hl)
        ld (hl),a

        ld hl,sysarub           ;*** Drive B speichern
        ld de,risc_disc_b
        ld a,d
        ld d,e
        ld e,0
        ld c,7
        ld ix,16*2+prgaruobj0+5
        ld iy,sysarul+0
        call imgsav


sysaruj ld a,(prgwinrun)        ;*** Fenster schlieen
        ld b,a
        ld c,MSC_DSK_WINCLS
        call msgsnd

sysarug ld a,1
        ld (prgaruobj1+2),a
        ld a,4
        ld (prgaruobj0+2),a
        ld hl,sysarutxt1b
        ld (sysarudsc1),hl
        jp prgprz0

;HL=Neuer Pfad, DE=Alter Pfad, C,IX=Control,IY=Speicher -> Disc Image laden, wenn ntig -> CF=1 wurde geladen
sysaru2 ld a,(hl)
        or a
        push bc
        push ix
        jr z,sysaru3
        push hl
        ld b,0
        ex de,hl
sysaru9 ld a,(de)
        cp (hl)
        ld (hl),a
        inc hl
        inc de
        jr z,sysaru8
        ld b,1
sysaru8 or a
        jr nz,sysaru9
        pop hl
        dec b
        jr nz,sysaru3
        db #fd:ld a,h
        db #fd:ld d,l
        ld e,0
        call imglod
        scf
sysaru3 pop ix
        pop de
        ld (ix+0),255
        push af
        call imglod9
        pop af
        ret

sysaruf xor a
        ld (16*0+prgaruobj0+5),a
        ld (16*1+prgaruobj0+5),a
        ld (16*2+prgaruobj0+5),a
        ld hl,sysarutxt0
        ld (sysarudsc5),hl
        ld c,MSC_DSK_WINOPN     ;*** Fenster ffnen
        ld a,(prgbnknum)
        ld b,a
        ld de,prgarudat
        call msgsnd             ;Fenster aufbauen
sysaru1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        scf
        ret z
        cp MSR_DSK_WOPNOK
        jr nz,sysaru1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (prgwinrun),a            ;Fenster wurde geffnet -> Nummer merken
        inc a
        ld (prgwindat+windatsup),a  ;Superfenster eintragen
        ret


;### RISCWR -> Erweiterten Speicher beschreiben
;### Eingabe    HL=Quelle, A,DE=Ziel, BC=Lnge
;### Verndert  AF,BC,DE,HL,IX
riscwr  push bc
        pop ix
        ld c,a
        ex de,hl
riscwr1 ld a,(de)
        inc de
        dw risc_byte_write
        inc hl
        dec ix
        db #dd:ld a,l
        db #dd:or h
        jr nz,riscwr1
        ret

;;### RISCRD -> Erweiterten Speicher auslesen
;;### Eingabe    A,HL=Quelle, DE=Ziel, BC=Lnge
;;### Verndert  AF,BC,DE,HL,IX
;riscrd  push bc
;        pop ix
;        ld c,a
;riscrd1 dw risc_byte_read
;        inc hl
;        ld (de),a
;        inc de
;        dec ix
;        db #dd:ld a,l
;        db #dd:or h
;        jr nz,riscrd1
;        ret

;### RISCGO -> Ruft den CPC auf
;riscgos dw 0
riscgo  di
        ex af,af'
        exx
        push af
        ld a,i
        push af
        push bc
        push de
        push hl
        ld hl,(#38)
        push hl
        ld hl,#c9fb
        ld (#38),hl
        ld	a,#c1
        ld bc,SYSIO            
        out	(c),a        ;Screen auf "normal" schalten
						;ab gehts...
;HIER code fuer F12 rein 	        
		ld	bc,FDCSTAT
riscgo1 in	a,(c)
		add	a,a
		jr	c,riscgo2
		jp  p,riscgo3			;data ready
		call tfdcin  
		jr	riscgo1      
riscgo3	call tfdcout:
		jr	riscgo1      
		
riscgo2	and	#4				;F12?
		jr	z,riscgo1
        
       
        
riscgo0 di                      ;...und wieder zurck
        pop hl
        ld (#38),hl
        pop hl
        pop de
        pop bc
        pop af
        ld i,a
        pop af
        exx
        ex af,af'
        ld	a,#40
        ld bc,SYSIO            
        out	(c),a         		;Screen auf "schatten" schalten
        ei
        ret

;FDC-Emu
ptrreadstart:		ds	7
PCN:				ds	1
driveselect:		ds	1
hptrtrack:			ds 	1
ptrtrack:			ds	2
ptrread:			ds	2
readcount:			ds	2
ptrcommandstart:	ds	9
bytecount:			ds	2
hptrcommand:		ds	1
ptrcommand:			ds	2
commandcount:		ds	1
mainstatus:			ds	1
dskwritestat:		ds	1
dsk_writemask:		ds	1
dsk_base:			ds	1
sint_state:			ds	1
;-----------------------------------------------------------------
; OUT fr Turbo
;-----------------------------------------------------------------
tfdcout:		ld    	bc,FDCIO
			in		e,(c)	
	ld	a,'O'
	call	txtchar
											;=0001 alle da
			ld		hl,(bytecount)				;=0000 lesen letzte
			inc		hl						;=FFFF lesen vorletzte d=5
			ld		a,h
			or		l
			ld		d,#03
			jp		m,tfdc1
			ld		d,#05
			jr		z,tfdc1
			dec		a
			jr		nz,twnorm
			ld		d,a
tfdc1:		ld		(bytecount),hl


			ld		a,(hptrcommand)
			ld		c,a
			ld		hl,(ptrcommand)	;read data
			ld		a,e
;			dw		077edh
			dw risc_byte_write

;	call	txtchar
;	ld		a,' '
;	call	txtchar
			
			inc	l
			jr		nz,tfdc2
			inc	h
			jr		nz,tfdc2
			ld		a,(hptrcommand)
			add	#01
			ld		(hptrcommand),a
tfdc2:		ld		(ptrcommand),hl
			ld		a,d			;status
			or		a
			jp		z,trnorm
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret

			
twnorm:		ld		a,(commandcount)			;alle commandos einlesen
			or		a								;<0 alles da
			jp		m,tnewcommand				;=0 letztes Zeichen
			ld		hl,(ptrcommand)
			ld		(hl),e
			inc	hl
			ld		(ptrcommand),hl
			dec	a
			ld		(commandcount),a
			jp		m,texcommand
			ld		a,#1			;status
			jr		nz,tfdc3
			ld		a,(mainstatus)
tfdc3:	;	dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret


texcommand:
;	ld		a,'E'
;	call	txtchar
;	ld		a,'X'
;	call	txtchar
;	ld		a,' '
;	call	txtchar

		;Commando komplett
			ld		hl,risc_disc_a
			ld		a,h
			ld		(dsk_base),a
			ld		a,#0f
			ld		(dsk_writemask),a
			ld		a,(ptrcommandstart+1)
			and		03
			jr		z,texcommand1
			ld		hl,risc_disc_b
			ld		a,h
			ld		(dsk_base),a
			ld		a,#f0
			ld		(dsk_writemask),a

texcommand1:
			ld		a,(ptrcommandstart)
			cp		#08
			jr		z,texcommand2
			ld		(sint_state),a
texcommand2			
			ld		hl,ptrreadstart
			ld		(ptrread),hl


			cp		#04			;sense drive status
			jr		nz,trecalibrate
 ;hier noch erweitern
			ld		(hl),#20		;sense drive status
			ld		a,1
			jp		tsetwrite
	
trecalibrate:
			cp		#07
			jr		nz,ttseek

			xor	a				;recalibrate
			ld		(PCN),a
			ld		a,#01		;status
tskip:	;dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret


ttseek:	cp		#0f
			jr		nz,ttseek1			;seek
			ld		a,(ptrcommandstart+2)
			ld		(PCN),a
;			call		calctadr
;			ld		(hptrtrack),a
;			ld		(ptrtrack),hl
			ld		a,#01		;status
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret


ttseek1:	cp		#03	;specify		
			jr		nz,ttseek2
			ld		a,#01		;status
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret




ttseek2:	cp		#08
			jr		nz,readID
			ld		a,(sint_state)
			cp		03
			ld		a,#80
			jr		z,ttseek3
			ld		a,#20
ttseek3:	ld		(hl),a		;sense interrupt status
			ld		a,#08
			ld		(sint_state),a
			inc		hl
			ld		a,(PCN)
			ld		(hl),a
			ld		a,2
			jp		tsetwrite

readID:		or		#40
			cp		#4a
			jr		nz,twritedata			;READ ID
			ld		a,(ptrcommandstart+1)
			ld		(driveselect),a
			call 	tcalctadr
			push		af
			ld		de,#0018
			add		hl,de
;			dw		7eedh
			dw risc_byte_read

			ld		(ptrreadstart+3),a	;C
			inc		hl
;			dw		7eedh
			dw risc_byte_read

			ld		(ptrreadstart+4),a	;H
			inc		hl
;			dw		7eedh
			dw risc_byte_read

			ld		(ptrreadstart+5),a	;R
			inc		hl
;			dw		7eedh
			dw risc_byte_read

			ld		(ptrreadstart+6),a	;N
			xor	a
			ld		(ptrreadstart+0),a	;ST0
			inc		hl
;			dw		7eedh
			dw risc_byte_read

			ld		(ptrreadstart+1),a	;ST1
			inc		hl
			pop		af
			jr		nc,ttseek4
			ld		a,#05
			ld		(ptrreadstart+1),a	;ST1

ttseek4:;			dw		7eedh
			dw risc_byte_read

			ld		(ptrreadstart+2),a	;ST2
			
;			ld		a,8		???
			ld		a,7
			jp		tsetwrite
;			ld		(hl),a
;			ld		hl,mainstatus
;			set	4,(hl)		;Schreibphase luft
;			ld		a,(mainstatus)
;			set	4,a			;Schreibphase luft
;			ld		a,5
;			dw		0eaedh

twritedata:
			cp		#45
			jr		nz,ttseek5		;Write Data
			call	tmakedata
			ld		hl,dskwritestat		;Dsk verndert
			ld		a,(dsk_writemask)
			or		(hl)
			ld		(hl),a
			ld		a,7
			ld		(readcount),a	
			ld		a,#03					;status
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret

ttseek5:		or		#60
			cp		#66
			jr		nz,tskip2		;READ DATA

			call	tmakedata
			ld		a,7
			ld		(readcount),a
			jp		tfdcin

			ld		a,#07					;status
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret
			
tskip2:				;invalid
			ld		(hl),#80		;sense interrupt status
			ld		a,1
			jp		tsetwrite

tnewcommand:
			ld		hl,ptrcommandstart
			ld		(hl),e
			inc	hl
			ld		(ptrcommand),hl
			ld		hl,commandcount
			ld		a,e
	call	txtchar
			cp		#08				;sense interrupt status
			jp		z,texcommand

			cp		#04				;sense drive status
			jr		nz,ttseek6
			ld		(hl),0
			ld		a,#05
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret

ttseek6:		cp		#0f				;seek
			jr		nz,ttseek7
			ld		(hl),1
			xor	a
			ld		(mainstatus),a
			inc	a
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret


ttseek7:		cp		#03				;specify
			jr		nz,tcprdid
;tsetread2:
			ld		(hl),1
			xor	a
			ld		(mainstatus),a
			inc	a
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret

tcprdid:		or		#40
			cp		#4A				;Read ID
			jr		nz,ttseek8		;tsetread1
			ld		(hl),0	;2Bytebefehl
			ld		a,5		;lesen
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret

ttseek8:		cp		#45				;Write DATA
			jr		nz,ttseek9
			ld		(hl),7
			ld		a,3
			ld		(mainstatus),a
			ld		a,#01
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret

ttseek9:		or		#60
			cp		#66				;Read DATA
			jr		nz,tcprec
;tsetread8:
			ld		(hl),7
			ld		a,7
			ld		(mainstatus),a
			ld		a,#01
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret

tcprec:	ld		a,e	
			cp		07
			jr		nz,tskip3
		
tsetread1:
			ld		a,0			;recalibrate
			ld		(hl),a
;			dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret


tskip3:	call	txtchar
			ld		a,'F'
		call	txtchar
			ld		a,'e'
			call	txtchar
			ld		a,'h'
			call	txtchar
			ld		a,'l'
			call	txtchar
			ld		a,'e'
			call	txtchar
			ld		a,'r'
			call	txtchar
			ld		a,'!'
			call	txtchar
;tskip2:			ld		a,#80
;			dw		0eaedh
			jp		texcommand





;-----------------------------------------------------------------
; fdcin fr turbo
;-----------------------------------------------------------------

			
tfdcin:
	ld	a,'I'
	call	txtchar
			ld		hl,(bytecount)
			ld		a,h
			or		l
			ld		e,#07
			jp		m,tfdcin1
			jr		nz,trnorm
			ld		e,#05
tfdcin1:		inc	hl
			ld		(bytecount),hl

			ld		a,(hptrcommand)
;			ld		b,a
;			ld		c,9ch
			ld		c,a
;	call	txtchar
			ld		hl,(ptrcommand)	;read data
;			dw		07eedh
			dw risc_byte_read

			ld		bc,FDCIO
			out		(c),a
			
			inc		l
			jr		nz,tfdcin2
			inc		h
			jr		nz,tfdcin2
			ld		a,(hptrcommand)
			add		#01
			ld		(hptrcommand),a
tfdcin2:		ld		(ptrcommand),hl
			ld		a,e				;status
;$$:		;	dw		0eaedh
			ld 		bc,FDCSTAT
			out		(c),a
			ret
			

tsetwrite:
			ld		(readcount),a	
trnorm:
			ld		hl,(ptrread)	;read data
			ld		a,(hl)
			ld		bc,FDCIO
			out	(c),a
			inc	hl
			ld		(ptrread),hl
			ld		hl,readcount
			dec	(hl)
			ld		a,#01
			jp		m,trnorm1
			ld		a,#d5			;status
			jr		nz,trnorm1
			ld		a,#d0			;status
trnorm1:		;	dw		0eaedh
;	call	txtchar
			ld 		bc,FDCSTAT
			out		(c),a
			ret



			
tmakedata:
			ld		(hl),#00		;ST0
			inc	hl
			ld		(hl),0		;ST1
			push		hl
			inc	hl
			ld		(hl),0		;ST2
			inc	hl
			ld		a,(ptrcommandstart+2)
			ld		(hl),a		;C
			inc	hl
			ld		a,(ptrcommandstart+3)
			ld		(hl),a		;H
			inc	hl
			ld		a,(ptrcommandstart+4)
			add	#c0				;Warum?
			ld		(hl),a		;R
			inc	hl
			ld		a,(ptrcommandstart+5)
			ld		(hl),a		;N
			ld		hl,#fe01
			ld		(bytecount),hl
;			push	de
			call		tcalctadr
			call		nc,tcalcsadr
			pop		hl
			ret		nc
			ld		(hl),#05		;ST1

;			ld		a,(hptrcommand)
;			rrca
;			rrca
;			rrca
;			rrca
;			and	0fh
;			call	txtbyte
;			ld		a,h
;			call	txtbyte
;			ld		a,l
;			call	txtbyte
;			ld		a,' '
;			call	txtchar

;			pop	de
			ret

;berechne Trackadresse
tcalctadr:	ld		hl,#00
			ld		a,(dsk_base)
			ld		c,a
			dw risc_byte_read
			ld		d,a
			inc		hl
			dw risc_byte_read
			cp		'V'
			jr		z,tmvdisk
			cp		'X'
			jr		nz,tnodisc
			ld		a,d
			cp		'E'
			jr		nz,tnodisc
;Extended cpc disk
			ld		l,#31	
			dw	risc_byte_read				;number of sides
			ld		l,#34	;track size table
			ld		de,#0001
			dec		a
			ld		a,(PCN)
			jr		z,exsingle
;double side		
			add		a,a
			ld		b,a
			ld		a,(ptrcommandstart+1)
			and		#04		;head
			jr		z,tcalctadr1
			inc		b
tcalctadr1:	ld		a,b

;single side
exsingle:		or		a
			jr		z,exstrack0
			ld		b,a
exsingle1:	dw risc_byte_read
			add		e
			ld		e,a
			adc		d
			sub		e
			ld		d,a
			inc		hl
			djnz	exsingle1
exstrack0:
			ld		h,e
			ld		a,c
			add		a,d
			ld		c,a
			xor		a	;nc->OK
			ld		l,a
			ret

;MV cpc Disk	
tmvdisk:	ld		a,d
			cp		'M'
			jr		nz,tnodisc

;			ld		a,(dsk_base)
;			ld		c,a

			ld		hl,#0033	;size of a track
			dw risc_byte_read
			ld		d,a
			dec		hl
			dw risc_byte_read		
			ld		e,a
			dec		hl
			dw risc_byte_read				;number of sides
			ld		hl,#0100
			dec		a
			jr		z,tsingle		;single side

			ld		a,(ptrcommandstart+1)
			and		#04		;head
			jr		z,tmvdisk1
			add		hl,de
tmvdisk1:	ex		de,hl
			add		hl,hl
			ex		de,hl
tsingle:	ld		a,(PCN)
			or		a
			ret		z
			ld		b,a
			ld		a,c
tsingle1:	add		hl,de
			adc		a,#0
			djnz	tsingle1
			ld		c,a
			xor		a	;nc->OK
			ret

;tcalct2:		ld		a,(dsk_base)
			add		a,h
			ld		c,a
			ld		h,l
			xor		a	;nc->OK
			ld		l,a
			ret

tnodisc:	
		;	ld	c,0
			scf			;c->fehler
			ret

; berechne Sectoradresse
tcalcsadr:	push	hl
			ld		e,#1
			ld		l,#14
			dw risc_byte_read
			ld		d,a		;sector size
			inc		l
			dw risc_byte_read
			ld		b,a		;number of sectors
			ld		l,#1a	;sector ID
tcalcsadr1:	dw risc_byte_read			;sector ID
			push		de
			ld		e,a
			ld		a,(ptrcommandstart+4)	;R
			cp		e
			pop		de
			jr		z,tcalcsadr2
			ld		a,e
			add		a,d
			ld		e,a
			ld		a,l
			add		a,#8
			ld		l,a
			djnz	tcalcsadr1
			pop		hl
			scf				;c->Fehler
			ret
																																																																																																																																																																																																																								
tcalcsadr2:	pop		hl
			ld		a,h
			add		a,e
			ld		h,a
			ld		a,c
			adc		a,#0		;nc->OK

			ld		(hptrcommand),a
			ld		(ptrcommand),hl
;			or		a		;nc->OK
			ret			
			
txtchar:	push		bc
txtchar1	ld		bc,#FC04
			in		c,(c)
			bit		0,c
			jr		nz,txtchar1
			ld		bc,#FC07
			out		(c),a
			pop		bc
			ret

;==============================================================================
;### LOADING-ROUTINEN #########################################################
;==============================================================================

;### IMGLOD -> Ldt ein Image (ROM oder DSK) in den erweiterten Speicher
;### Eingabe    HL=Filename, A,DE=ZielAdresse (24Bit), C=Fortschrittsbalken-Control oder 0, IX=Fortschritts-Adr
;### Ausgabe    CF=0 alles ok, CF=1 Fehler whrend des Ladens (A=Errorcode)
imglodadr   ds 3
imglodcon   db 0
imglodpro   dw 0
imglodhnd   db 0
imglodsiz   db 0    ;Image Gre/16K
imglodcnt   db 0
imglodsizf  ds 4

imglod  ld (sysarudsc5),hl
        ld (imglodadr+0),de
        ld (imglodadr+2),a
        ld (imglodpro),ix
        xor a
        ld (imglodcnt),a
        ld a,c
        ld (imglodcon),a
        ld a,(prgbnknum)    ;*** Image ffnen
        db #dd:ld h,a
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN
        ret c
        ld (imglodhnd),a
        ld e,8
        call imglod9
        ld c,2              ;*** Lnge feststellen
        call imglod1
        ld (imglodsizf+0),ix
        ld (imglodsizf+2),iy
        db #fd:ld a,l
        db #dd:ld e,h           ;AE=Lnge/256
        sla e:rla
        sla e:rla               ;A=Lnge/16384
        inc a
        ld (imglodsiz),a
        ld c,0              ;*** Amsdos-Header bei ROM-Images berspringen (falls vorhanden)
        call imglod1
        ld hl,lodbuf
        ld de,(prgbnknum)
        ld bc,128
        ld a,(imglodhnd)
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        ld ix,lodbuf
        ld a,"R"
        cp (ix+09):jr nz,imglod2
        ld a,"O"
        cp (ix+10):jr nz,imglod2
        ld a,"M"
        cp (ix+11):jr z,imglod3
imglod2 ld c,0
        call imglod1
imglod3 ld a,(imglodhnd)    ;*** Daten laden
        ld hl,lodbuf
        ld de,(prgbnknum)
        ld bc,lodmax
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        ld a,c
        or b
        jr z,imglod7
        ld b,0              ;*** Daten in Speicher schreiben
        db #dd:ld l,lodmax/256
        ld a,(imglodadr+2)
        ld c,a
        ld hl,(imglodadr+0)
        ld de,lodbuf
imglod5 ld a,(de)
        inc de
        dw risc_byte_write
        inc hl
        djnz imglod5
        db #dd:dec l
        jr nz,imglod5
        ld a,l
        or h
        jr nz,imglod6
        inc c
imglod6 ld a,c
        ld (imglodadr+2),a
        ld (imglodadr+0),hl

        call imgsav5
        jr imglod3

imglod9 ld a,(prgwinrun)
        ld b,a
        jp msgsnd2
imglod7 ld a,(imglodhnd)    ;*** Image schlieen
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        ret
imglod1 ld a,(imglodhnd)
        ld ix,0
        ld iy,0
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILPOI
        ret

;### IMGSAV -> Speichert ein Image aus dem erweiterten Speicher
;### Eingabe    HL=Filename, A,DE=QuellAdresse (24Bit), C=Fortschrittsbalken-Control oder 0, IX=Fortschritts-Adr, (IY)=Gre
;### Ausgabe    CF=0 alles ok, CF=1 Fehler whrend des Speicherns (A=Errorcode)
imgsavsiz   ds 4
imgsav  push iy
        ld (sysarudsc5),hl
        ld (imglodadr+0),de
        ld (imglodadr+2),a
        ld (imglodpro),ix
        xor a
        ld (imglodcnt),a
        ld a,c
        ld (imglodcon),a
        ld a,(prgbnknum)    ;*** Image erstellen
        db #dd:ld h,a
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN
        pop hl
        ret c
        ld (imglodhnd),a
        ld de,imgsavsiz
        ld bc,4
        ldir
        ld hl,(imgsavsiz+1)
        ld a,h
        ld a,(imgsavsiz+2)      ;AL=Lnge/256
        sla l:rla
        sla l:rla               ;A=Lnge/16384
        inc a
        ld (imglodsiz),a
        ld e,8
        call imglod9

imgsav0 ld a,(imgsavsiz+2)  ;*** Daten aus Speicher lesen
        cp -1
        jr z,imglod7
        ld hl,(imgsavsiz+0)
        ld de,lodmax
        or a
        sbc hl,de
        ld (imgsavsiz+0),hl
        sbc 0
        ld (imgsavsiz+2),a
        jr nc,imgsav1
        add hl,de
        ex de,hl
imgsav1 ld a,e
        or d
        jp z,imglod7
        push de
        ld a,e
        or a
        jr z,imgsav2
        inc d
imgsav2 push de
        pop ix
        ld a,(imglodadr+2)
        ld c,a
        ld hl,(imglodadr+0)
        ld de,lodbuf
imgsav3 dw risc_byte_read
        ld (de),a
        inc de
        inc hl
        db #dd:dec l
        jr nz,imgsav3
        db #dd:dec h
        jr nz,imgsav3
        ld a,l
        or h
        jr nz,imgsav4
        inc c
imgsav4 ld a,c
        ld (imglodadr+2),a
        ld (imglodadr+0),hl

        ld a,(imglodhnd)    ;*** Daten speichern
        pop bc
        ld hl,lodbuf
        ld de,(prgbnknum)
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOUT

        call imgsav5
        jr imgsav0

imgsav5 ld hl,imglodcnt
        inc (hl)
        ld a,(hl)
        and 3
        ret nz
        ld a,(imglodcon)
        or a
        ret z
        push af             ;*** Fortschrittsbalken updaten (alle 16K)
        ld a,(hl)
        srl a:srl a
        ld b,a
        ld c,0
        ld a,(imglodsiz)
        ld e,a
        ld d,c
        call clcd16         ;HL=BC/DE
        ld a,l
        ld hl,(imglodpro)
        ld (hl),a
        pop af
        ld e,a
        jp imglod9

lodmax  equ 4096
lodbuf  db 0        ;### LETZTER LABEL! ###


;==============================================================================
;### DATEN-TEIL ###############################################################
;==============================================================================

prgdatbeg

;### Verschiedenes
prgmsginf1 db "R-BOX 880",0
prgmsginf2 db " Version 0.2 (Build 090715tfx)",0
prgmsginf3 db " Copyright <c> 2006-2009 SymbiosiS",0

prgwintit   db "Retro-Box 8bit-80ies 0.2",0

prgtxtok    db "Ok",0
prgtxtcnc   db "Cancel",0
prgtxtyes   db "Yes",0
prgtxtno    db "No",0

sysseltxt1  db "Commodore C64",0
sysseltxt2  db "Amstrad CPC",0
sysseltxt3  db "Direct Game Play",0
sysseltxt4  db "Please use arrow keys+return or joystick/mouse",0
sysseltxt5  db "(c) 2006-2009 by TobiFlex and Prodatron",0

sysseltxt0  db "System selection - take your choice...",0
sysseltxt6  db "Amstrad CPC Type and ROM selection",0
sysseltxt7  db "Amstrad CPC Disc selection",0
sysseltxt8  db "Commodore C64 Disc selection",0
sysseltxt9  db "Game selection",0

prgbutmsc1  db "Help",0
prgbutmsc2  db "About",0
prgbutmsc3  db "Quit",0
prgbutmsc4  db "Back",0

syscpctxt2  db "Configuration",0
syscpctxt3  db "Description",0

sysdsktxt0  db " Current configuration:",0

sysdsktxt1  db "Disc drive A",0
sysdsktxt2  db "Disc drive B",0

sysdsktxt5  db "Favourites",0
sysdsktxt6  db "Select Disc A...",0
sysdsktxt7  db "Select Disc B...",0
sysdsktxt8  db "START!...",0

sysarutxt1  db "Starting CPC..."
sysarutxt0  db 0
sysarutxt1b db "Writing back...",0
sysarutxt2  db "Rom configuration",0
sysarutxt3  db "Disc drive A",0
sysarutxt4  db "Disc drive B",0

;### Dummy-Rom, falls Config nicht lesbar ist
syscpctxta  db "Amstrad CPC 6128",0
syscpcdsca  db "2",0
            db "The CPC 6128 was the last",0
            db "CPC of the old generation",0
            db "developed by Amstrad in",0
            db "1985. It had a 4MHz Z80A",0
            db "CPU, 128K Ram, 48K Rom and",0
            db "an inbuilt 3",34," disc drive.",0
syscpcroml  db "c:\cpc-rom\os6128.rom",0
syscpcrom0  db "c:\cpc-rom\basic1-1.rom",0
syscpcrom7  db "c:\cpc-rom\amsdos.rom",0

;### Dummy-DSK-Favorit, falls Config nicht lesbar ist
sysdsktxta  db "SymbOS Boot Disc + Applications",0
sysdskdsca  db "The new CPC multitasking",0
            db "operating system includes",0
            db "a complete windows GUI.",0
            db "It's the most complex",0
            db "8bit project on the world.",0
sysdskdsca0 db "c:\cpc-dsk\symbos.dsk",0
sysdskdsca1 db "c:\cpc-dsk\sym-apps.dsk",0

;### Config
cfgtxt  db 0        ;### !!LETZTER LABEL!! ###


;==============================================================================
;### TRANSFER-TEIL ############################################################
;==============================================================================

prgtrnbeg
;### PRGPRZS -> Stack fr Programm-Prozess
        ds 128
prgstk  ds 6*2
        dw prgprz
prgprzn db 0
prgmsgb ds 14

;### Grafiken

sprsyslog   db 63,252,13    ;Logo
db #00,#00,#00,#00,#00,#01,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#88,#00,#00,#00,#00,#1E,#F0,#F0,#F0,#F0,#C3,#0C,#00,#00,#1F,#F0,#F0,#F0,#84,#01,#F0,#F0,#F0,#F0,#84,#13,#F0,#F0,#F0,#F0,#F0,#C3,#08,#00,#07,#F0,#F0,#F0,#C3,#08,#00,#07,#F0,#F0,#F0,#C3,#08,#00,#07,#F0
db #00,#00,#00,#00,#00,#00,#01,#F0,#F0,#F0,#F0,#F0,#F0,#88,#00,#00,#00,#00,#00,#7C,#F0,#F0,#E3,#00,#00,#00,#00,#00,#13,#F0,#F0,#F1,#00,#34,#F0,#F0,#E3,#00,#78,#F0,#F0,#F0,#F0,#F1,#08,#00,#00,#00,#36,#F0,#F1,#08,#00,#00,#00,#36,#F0,#F1,#08,#00,#00,#00,#36
db #00,#70,#F0,#F0,#F0,#C7,#00,#70,#F0,#F0,#F0,#F0,#F0,#88,#34,#F0,#F0,#F1,#08,#32,#F0,#F0,#08,#01,#3E,#F0,#F1,#0C,#00,#74,#F0,#F0,#C4,#01,#F0,#F0,#8C,#12,#F0,#F0,#F0,#F0,#F0,#E0,#00,#7C,#F0,#84,#11,#F0,#E0,#00,#7C,#F0,#84,#11,#F0,#E2,#00,#3C,#F0,#0C,#11
db #00,#70,#F0,#F0,#F0,#F0,#00,#70,#F0,#F0,#F0,#F0,#F0,#88,#34,#F0,#F0,#F0,#C4,#12,#F0,#E0,#00,#74,#F0,#F0,#F0,#F0,#08,#12,#F0,#F0,#F1,#08,#34,#E3,#00,#78,#F0,#F0,#F0,#F0,#F0,#E2,#11,#F0,#F0,#E0,#01,#F0,#E2,#11,#F0,#F0,#E0,#01,#F0,#C4,#12,#F0,#F0,#E1,#00
db #00,#70,#F0,#F0,#F0,#86,#00,#70,#F0,#F0,#F0,#F0,#F0,#88,#34,#F0,#F0,#E1,#08,#34,#F0,#C0,#01,#F0,#F0,#F0,#F0,#F0,#C2,#01,#F0,#F0,#F0,#C6,#11,#8C,#12,#F0,#F0,#F0,#F0,#F0,#F0,#E1,#00,#7C,#F0,#84,#12,#F0,#E1,#00,#7C,#F0,#84,#12,#F0,#84,#32,#F0,#F0,#F1,#00
db #00,#00,#00,#00,#00,#00,#01,#F0,#F0,#F0,#F0,#F0,#F0,#88,#00,#00,#00,#00,#01,#F8,#F0,#C4,#12,#F0,#F0,#F0,#F0,#F0,#E0,#00,#F8,#F0,#F0,#F1,#08,#00,#78,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#8E,#00,#00,#01,#7C,#F0,#F0,#8E,#00,#00,#01,#7C,#F0,#84,#34,#F0,#F0,#F0,#08
db #00,#00,#00,#00,#00,#03,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#88,#00,#00,#00,#00,#01,#7C,#F0,#84,#12,#F0,#F0,#F0,#F0,#F0,#E1,#00,#78,#F0,#F0,#F0,#88,#01,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#0C,#00,#00,#00,#3E,#F0,#F0,#0C,#00,#00,#00,#3E,#F0,#80,#34,#F0,#F0,#F0,#08
db #00,#70,#F0,#C3,#00,#3C,#F0,#F0,#84,#00,#00,#01,#F0,#88,#34,#F0,#F0,#F0,#0C,#11,#F0,#84,#12,#F0,#F0,#F0,#F0,#F0,#E0,#00,#F8,#F0,#F0,#C2,#00,#08,#34,#F0,#F0,#F0,#F0,#F0,#F0,#C6,#01,#78,#F0,#86,#01,#F8,#C6,#01,#78,#F0,#86,#01,#F8,#84,#30,#F0,#F0,#F0,#00
db #00,#70,#F0,#F0,#C4,#01,#F8,#F0,#C4,#00,#00,#11,#F0,#88,#34,#F0,#F0,#F0,#E0,#00,#F8,#C0,#01,#F0,#F0,#F0,#F0,#F0,#C2,#01,#F0,#F0,#F0,#08,#32,#C6,#01,#F0,#F0,#F0,#F0,#F0,#F0,#84,#30,#F0,#F0,#F0,#08,#70,#84,#30,#F0,#F0,#F0,#08,#70,#84,#30,#F0,#F0,#F0,#00
db #00,#70,#F0,#F0,#F1,#00,#36,#F0,#F0,#F0,#F0,#F0,#F0,#88,#34,#F0,#F0,#F0,#E0,#00,#F8,#E1,#00,#3C,#F0,#F0,#F0,#F0,#08,#12,#F0,#F0,#C2,#00,#F8,#F1,#08,#34,#F0,#F0,#F0,#F0,#F0,#80,#30,#F0,#F0,#F0,#08,#70,#80,#30,#F0,#F0,#F0,#08,#70,#C0,#12,#F0,#F0,#E1,#00
db #00,#70,#F0,#F0,#F0,#C4,#01,#F0,#F0,#F0,#F0,#F0,#F0,#88,#34,#F0,#F0,#F0,#0C,#01,#F0,#F0,#88,#01,#3E,#F0,#F1,#0C,#00,#34,#F0,#F0,#08,#32,#F0,#F0,#C6,#01,#F0,#F0,#F0,#F0,#F0,#C4,#01,#78,#F0,#C6,#00,#F8,#C4,#01,#78,#F0,#C6,#00,#F8,#E2,#00,#3C,#F0,#0C,#11
db #00,#70,#F0,#F0,#F0,#E1,#00,#34,#F0,#F0,#F0,#F0,#F0,#88,#00,#00,#00,#00,#00,#32,#F0,#F0,#E3,#00,#00,#00,#00,#00,#13,#F0,#F0,#C2,#01,#F8,#F0,#F0,#F1,#08,#34,#F0,#F0,#F0,#F0,#E1,#00,#00,#00,#00,#13,#F0,#E1,#00,#00,#00,#00,#13,#F0,#F1,#08,#00,#00,#00,#36
db #00,#70,#F0,#F0,#F0,#F0,#8C,#01,#F0,#F0,#F0,#F0,#F0,#88,#00,#00,#00,#00,#07,#F0,#F0,#F0,#F0,#C3,#0C,#00,#00,#1F,#F0,#F0,#F1,#08,#36,#F0,#F0,#F0,#F0,#C4,#01,#F8,#F0,#F0,#F0,#F0,#C7,#00,#00,#03,#F8,#F0,#F0,#C7,#00,#00,#03,#F8,#F0,#F0,#C3,#08,#00,#07,#F0

db #F0,#F0,#F0,#F0,#F0,#F1,#8C,#00,#00,#00,#00,#00,#00,#78,#F0,#F0,#F0,#F0,#EE,#00,#00,#00,#00,#33,#FC,#F0,#F0,#EF,#00,#00,#00,#74,#F1,#00,#00,#00,#00,#74,#E3,#00,#00,#00,#00,#00,#33,#F8,#F0,#F7,#00,#00,#00,#33,#F8,#F0,#F7,#00,#00,#00,#33,#F8,#F0,#F7,#00
db #F0,#F0,#F0,#F0,#F0,#F0,#F1,#00,#00,#00,#00,#00,#00,#78,#F0,#F0,#F0,#F0,#F0,#8C,#00,#00,#13,#F0,#F0,#F0,#F0,#F0,#E3,#00,#00,#01,#F0,#C4,#00,#00,#13,#F0,#88,#00,#00,#00,#00,#01,#F8,#F0,#F0,#F0,#C6,#00,#01,#F8,#F0,#F0,#F0,#C6,#00,#01,#F8,#F0,#F0,#F0,#C6
db #F0,#80,#00,#00,#00,#37,#F0,#80,#00,#00,#00,#00,#00,#78,#C4,#00,#00,#01,#F8,#C2,#00,#00,#F8,#F1,#CE,#00,#01,#FC,#F0,#84,#00,#00,#34,#F1,#00,#00,#7C,#E2,#00,#00,#00,#00,#00,#10,#F0,#8C,#00,#74,#E1,#00,#10,#F0,#8C,#00,#74,#E1,#00,#12,#F0,#CC,#00,#FC,#E1
db #F0,#80,#00,#00,#00,#00,#F0,#80,#00,#00,#00,#00,#00,#78,#C4,#00,#00,#00,#34,#E2,#00,#10,#F0,#84,#00,#00,#00,#00,#F8,#E2,#00,#00,#01,#F8,#C4,#13,#F0,#88,#00,#00,#00,#00,#00,#12,#E1,#00,#00,#10,#F1,#00,#12,#E1,#00,#00,#10,#F1,#00,#34,#E2,#00,#00,#11,#F0
db #F0,#80,#00,#00,#00,#76,#F0,#80,#00,#00,#00,#00,#00,#78,#C4,#00,#00,#11,#F8,#C4,#00,#30,#F1,#00,#00,#00,#00,#00,#32,#F1,#00,#00,#00,#36,#E1,#7C,#E2,#00,#00,#00,#00,#00,#00,#11,#F0,#8C,#00,#74,#E2,#00,#11,#F0,#8C,#00,#74,#E2,#00,#74,#C2,#00,#00,#01,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F1,#00,#00,#00,#00,#00,#00,#78,#F0,#F0,#F0,#F0,#F1,#08,#00,#34,#E2,#00,#00,#00,#00,#00,#10,#F0,#08,#00,#00,#01,#F8,#F0,#88,#00,#00,#00,#00,#00,#00,#00,#7E,#F0,#F0,#F1,#8C,#00,#00,#7E,#F0,#F0,#F1,#8C,#00,#74,#C4,#00,#00,#00,#F8
db #F0,#F0,#F0,#F0,#F0,#F3,#8C,#00,#00,#00,#00,#00,#00,#78,#F0,#F0,#F0,#F0,#F1,#8C,#00,#74,#E2,#00,#00,#00,#00,#00,#11,#F0,#88,#00,#00,#00,#78,#F1,#00,#00,#00,#00,#00,#00,#00,#00,#FC,#F0,#F0,#F0,#CE,#00,#00,#FC,#F0,#F0,#F0,#CE,#00,#70,#C4,#00,#00,#00,#F8
db #F0,#80,#00,#33,#F0,#CC,#00,#00,#74,#F0,#F0,#F1,#00,#78,#C4,#00,#00,#00,#FC,#E1,#00,#74,#E2,#00,#00,#00,#00,#00,#10,#F0,#08,#00,#00,#32,#F0,#F8,#C4,#00,#00,#00,#00,#00,#00,#36,#F1,#88,#00,#76,#F1,#08,#36,#F1,#88,#00,#76,#F1,#08,#74,#C0,#00,#00,#00,#F0
db #F0,#80,#00,#00,#34,#F1,#08,#00,#34,#F0,#F0,#E1,#00,#78,#C4,#00,#00,#00,#10,#F0,#08,#30,#F1,#00,#00,#00,#00,#00,#32,#F1,#00,#00,#00,#F8,#C2,#36,#F1,#00,#00,#00,#00,#00,#00,#74,#C0,#00,#00,#00,#F8,#80,#74,#C0,#00,#00,#00,#F8,#80,#74,#C0,#00,#00,#00,#F0
db #F0,#80,#00,#00,#01,#F0,#C6,#00,#00,#00,#00,#00,#00,#78,#C4,#00,#00,#00,#10,#F0,#08,#11,#F0,#CC,#00,#00,#00,#00,#F8,#E2,#00,#00,#32,#F0,#08,#01,#F8,#C4,#00,#00,#00,#00,#00,#70,#C0,#00,#00,#00,#F8,#80,#70,#C0,#00,#00,#00,#F8,#80,#30,#E2,#00,#00,#11,#F0
db #F0,#80,#00,#00,#00,#34,#F1,#00,#00,#00,#00,#00,#00,#78,#C4,#00,#00,#00,#FC,#F1,#00,#00,#78,#F1,#CE,#00,#01,#FC,#F0,#C4,#00,#00,#F8,#C2,#00,#00,#36,#F1,#00,#00,#00,#00,#00,#34,#F1,#88,#00,#36,#F0,#08,#34,#F1,#88,#00,#36,#F0,#08,#12,#F0,#CC,#00,#FC,#E1
db #F0,#80,#00,#00,#00,#11,#F0,#C4,#00,#00,#00,#00,#00,#78,#F0,#F0,#F0,#F0,#F0,#C2,#00,#00,#13,#F0,#F0,#F0,#F0,#F0,#E3,#00,#00,#32,#F1,#08,#00,#00,#01,#F8,#C4,#00,#00,#00,#00,#11,#F0,#F0,#F0,#F0,#E3,#00,#11,#F0,#F0,#F0,#F0,#E3,#00,#01,#F8,#F0,#F0,#F0,#C6
db #F0,#80,#00,#00,#00,#00,#7C,#F1,#00,#00,#00,#00,#00,#78,#F0,#F0,#F0,#F0,#F7,#00,#00,#00,#00,#33,#FC,#F0,#F0,#EF,#00,#00,#01,#F8,#C6,#00,#00,#00,#00,#34,#F1,#08,#00,#00,#00,#00,#37,#F0,#F0,#F3,#08,#00,#00,#37,#F0,#F0,#F3,#08,#00,#00,#33,#F8,#F0,#F7,#00

sprsyscpc   db 25,100,70    ;CPC-Grafik
db #00,#00,#00,#00,#00,#07,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#47,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#AF,#BF,#5F,#4F,#AF,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#F0,#F0,#F0,#F0,#F2,#F5,#F7,#F7,#F4,#F0,#F0,#F0,#F0,#8E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#F0,#F7,#CF,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#7F,#FD,#F0,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#FF,#6F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#7F,#FF,#0F,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#CF,#FA,#FA,#FF,#FF,#AF,#FF,#5F,#7F,#FF,#F5,#F7,#9F,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#8F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FE,#FF,#8F,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#8F,#FF,#FD,#FF,#FF,#FF,#FF,#FF,#FF,#FE,#FF,#F5,#8F,#2F,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#8F,#FF,#F7,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FD,#FF,#8F,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#0F,#FB,#FF,#FD,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FE,#8F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#8F,#FF,#FF,#FF,#FF,#FD,#FF,#FF,#FF,#FF,#FF,#FF,#8F,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#8F,#FF,#FF,#FF,#FD,#FF,#FD,#FF,#FB,#F7,#FD,#FE,#8F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#8F,#FB,#FF,#F7,#FF,#FF,#FF,#FE,#FF,#FD,#FF,#FF,#8F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#8F,#F7,#FF,#FD,#FF,#F7,#FF,#FF,#FF,#FF,#FF,#F7,#8F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#8F,#FF,#FB,#FF,#FF,#FF,#FF,#F7,#FF,#FF,#FF,#FF,#8F,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#8F,#FF,#FF,#FF,#FB,#FD,#FD,#FF,#FF,#FF,#FD,#FF,#8F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#9F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F7,#F7,#FF,#FF,#8F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#8F,#FF,#F7,#FD,#FE,#FF,#FF,#FB,#FF,#FF,#FF,#FF,#8F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#07,#9F,#FF,#FD,#FB,#FB,#FF,#FF,#FF,#FF,#FF,#FF,#FE,#8F,#8E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#CF,#F7,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FD,#F7,#FF,#CF,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#9F,#FF,#FF,#FF,#FD,#F6,#FF,#F7,#FF,#FF,#FF,#F7,#8F,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#DF,#FF,#FF,#FF,#FF,#FF,#FB,#FF,#FB,#FB,#FF,#FF,#CF,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#9F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FD,#FF,#97,#8E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#DF,#FF,#FF,#FD,#FF,#FF,#FF,#FF,#FE,#FF,#FF,#FB,#CF,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#DF,#FF,#FF,#FF,#FE,#FF,#FF,#FD,#FF,#FF,#FF,#FF,#9F,#2E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#17,#DF,#FF,#FF,#FF,#FF,#FF,#FB,#FF,#FF,#FF,#FE,#FF,#CF,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#DF,#FF,#F7,#FD,#FF,#FF,#FF,#FF,#FB,#FF,#FF,#FF,#BF,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#DF,#FF,#FF,#FF,#FF,#FD,#FE,#FE,#FE,#FB,#FF,#FF,#C7,#8E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#27,#FF,#F7,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FD,#DF,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#DF,#FD,#FD,#FF,#FD,#FF,#FF,#FF,#FF,#FF,#F5,#FF,#EF,#8E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FF,#FF,#FF,#FF,#FF,#FF,#FB,#FB,#FF,#FF,#FF,#FD,#D7,#8E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FF,#FF,#FF,#FF,#FF,#FD,#FF,#FF,#FD,#FF,#FF,#FE,#FF,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FF,#FD,#FD,#FB,#F6,#FF,#FF,#FF,#FF,#FD,#FF,#FF,#FF,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#F7,#FF,#F7,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FE,#FA,#FF,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FF,#FD,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#8E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FF,#FD,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#8E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FB,#FE,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FD,#D7,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FF,#FB,#FF,#FF,#FF,#FF,#FF,#FF,#FB,#FF,#FF,#FF,#FF,#EE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FB,#FE,#FA,#FD,#F6,#FF,#FF,#FF,#FF,#F5,#FA,#FA,#7F,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#F1,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#AF,#FF,#CE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#FF,#FF,#FF,#FF,#FF,#BF,#6F,#AF,#AF,#AF,#FF,#FF,#DF,#AE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#8F,#0F,#0F,#0F,#0F,#4F,#AF,#AF,#AF,#1F,#0F,#0F,#0F,#EE,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#8F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#6E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#37,#7F,#AF,#AF,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#2F,#8F,#2F,#6E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#35,#FF,#FB,#FE,#F8,#FB,#FF,#DF,#FF,#FF,#FF,#F7,#FF,#F7,#EC,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#34,#F0,#F4,#F3,#F7,#F6,#FF,#FD,#FF,#FE,#F9,#FA,#F8,#FD,#E7,#00,#00,#00,#00,#00
db #00,#11,#2F,#0F,#0F,#7F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F8,#F0,#F0,#84,#00
db #00,#12,#EF,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#1F,#FF,#FF,#FF,#8C,#00
db #00,#33,#EF,#0F,#0F,#0F,#0F,#0F,#5F,#2F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#2F,#CF,#5F,#AF,#0F,#CC,#00
db #00,#37,#FF,#FF,#FF,#EF,#EF,#DF,#EF,#DF,#FF,#EF,#DF,#DF,#BF,#FF,#AF,#5F,#5F,#0F,#0F,#0F,#0F,#4A,#00
db #00,#37,#4E,#0E,#0F,#0B,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#07,#0E,#0E,#0F,#0F,#2F,#5F,#3F,#0F,#2F,#EC,#00
db #00,#73,#CE,#04,#08,#09,#00,#02,#00,#00,#00,#01,#00,#02,#00,#00,#08,#01,#8F,#AF,#0F,#0F,#0F,#2F,#00
db #00,#6F,#8C,#00,#00,#00,#02,#00,#00,#00,#00,#00,#00,#00,#00,#08,#00,#09,#2F,#AF,#0F,#0F,#0F,#3F,#00
db #00,#7F,#8C,#02,#02,#04,#08,#08,#09,#01,#02,#04,#04,#08,#08,#04,#08,#01,#8F,#AF,#8F,#2F,#BF,#DF,#08
db #00,#DF,#0C,#08,#04,#01,#00,#01,#00,#00,#04,#00,#00,#00,#00,#00,#08,#08,#1F,#3F,#0F,#0F,#0F,#1F,#08
db #01,#F7,#09,#02,#02,#04,#04,#08,#09,#01,#01,#02,#00,#04,#04,#04,#00,#09,#AF,#DF,#0F,#8F,#4F,#3F,#8C
db #11,#DF,#08,#00,#09,#01,#02,#02,#00,#04,#00,#00,#00,#00,#00,#00,#0C,#00,#9F,#6F,#0F,#8F,#4F,#0F,#8C
db #11,#6F,#08,#00,#00,#00,#01,#00,#02,#00,#04,#08,#08,#00,#00,#04,#00,#08,#4F,#1F,#0F,#0F,#0F,#0F,#CC
db #32,#FF,#01,#01,#08,#02,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#04,#04,#2F,#EF,#8F,#0F,#0F,#0F,#4E
db #33,#EF,#00,#00,#00,#04,#00,#00,#00,#00,#00,#00,#00,#00,#00,#04,#00,#00,#0F,#2F,#AF,#FF,#FF,#0F,#6E
db #37,#6F,#05,#05,#05,#05,#04,#0A,#09,#00,#00,#00,#01,#00,#00,#02,#04,#08,#2F,#8F,#0F,#0F,#0F,#0F,#AF
db #37,#9F,#0F,#0F,#0F,#0F,#2F,#0F,#4F,#FF,#DF,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#1F,#3F,#F4,#FE,#F4,#F0,#F1
db #57,#5F,#5F,#2F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#BF,#F0,#F0,#F0,#F0,#F1
db #7B,#7F,#FF,#7F,#FF,#FF,#BF,#DF,#FF,#5F,#5F,#AF,#AF,#0F,#4F,#8F,#AF,#2F,#EF,#5F,#F0,#F0,#F0,#F0,#F0
db #78,#F4,#FA,#F3,#FF,#FD,#F7,#F9,#FE,#F0,#F1,#F6,#F2,#F0,#FC,#FB,#FE,#F2,#FE,#F4,#F0,#F0,#F0,#F0,#F0
db #F8,#F0,#F0,#F8,#F0,#F1,#F0,#F4,#F0,#F1,#FC,#F9,#FD,#F5,#F7,#F4,#F1,#F9,#F0,#F0,#F0,#F1,#F4,#F0,#F0
db #F8,#F0,#F2,#F0,#FA,#F0,#F4,#F9,#F4,#F8,#F1,#F3,#F3,#F2,#FE,#FB,#FF,#F2,#FA,#FC,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#F1,#F2,#F4,#FE,#F5,#F0,#F4,#F0,#F8,#F0,#F2,#F0,#F0,#F0,#F0,#F0

sprsysc64   db 25,100,70    ;C64-Grafik
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#07,#08,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#13,#0F,#0E,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#3F,#0E,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#0F,#0E,#08,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#0F,#0C,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#0F,#0C,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#0F,#0F,#0E,#00,#00,#00,#07,#08,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0F,#0F,#0F,#00,#00,#00,#00,#0F,#8C,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#07,#0F,#0F,#08,#00,#00,#01,#01,#F7,#CC,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#07,#0F,#0F,#0C,#00,#00,#00,#2F,#99,#F1,#8E,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#0F,#0F,#0C,#00,#00,#00,#1B,#7D,#8C,#F9,#2F,#01,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#03,#0F,#0F,#0E,#00,#00,#00,#11,#FC,#7C,#C4,#71,#FE,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#01,#0F,#0F,#0F,#00,#00,#00,#01,#FE,#FC,#F0,#CF,#30,#E7,#0C,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#0F,#0F,#0F,#08,#00,#00,#00,#7F,#F4,#F2,#E1,#7F,#10,#C7,#CE,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#07,#0F,#0F,#08,#00,#00,#00,#2F,#F6,#F2,#F4,#7C,#F0,#01,#F1,#CF,#01,#00,#00
db #00,#00,#00,#00,#00,#07,#0F,#0F,#0C,#00,#00,#00,#07,#FE,#F3,#F4,#FE,#F4,#F3,#0A,#78,#9F,#08,#00,#00
db #00,#00,#00,#00,#03,#0F,#0F,#0E,#00,#00,#00,#03,#7F,#F2,#F2,#B6,#F4,#F1,#9F,#84,#34,#FF,#88,#00,#00
db #00,#00,#00,#01,#1F,#0F,#0F,#00,#00,#00,#02,#7F,#F3,#F1,#F6,#F6,#F2,#F9,#FC,#C4,#32,#F3,#84,#04,#00
db #00,#00,#00,#2F,#2F,#0F,#00,#00,#00,#00,#7F,#FB,#F1,#F2,#F6,#F1,#F1,#FC,#F0,#A7,#11,#F0,#88,#00,#00
db #00,#00,#0F,#8F,#0F,#08,#00,#00,#00,#27,#FF,#F1,#F0,#D7,#F1,#F0,#FC,#F0,#F7,#F6,#00,#CE,#00,#02,#00
db #00,#07,#0F,#0F,#0E,#00,#00,#00,#07,#7F,#F2,#F0,#F7,#F0,#F0,#FC,#F4,#F0,#F3,#F0,#0A,#00,#00,#00,#08
db #07,#1F,#0F,#0F,#00,#00,#04,#02,#7F,#F3,#F1,#F7,#F2,#F1,#FC,#F6,#F0,#DF,#F0,#F0,#08,#00,#02,#05,#00
db #07,#0F,#0F,#00,#00,#04,#01,#6F,#D3,#F1,#F2,#F3,#F1,#F0,#F6,#F0,#F4,#F4,#F0,#E2,#00,#04,#08,#08,#04
db #47,#0F,#08,#08,#02,#00,#2E,#FF,#F1,#F0,#F7,#F0,#F0,#B6,#F2,#F0,#F6,#F0,#F1,#08,#05,#00,#06,#05,#0E
db #27,#0E,#02,#00,#08,#07,#FF,#F2,#F0,#F7,#F2,#F0,#F6,#F2,#F0,#F6,#F0,#F0,#84,#00,#00,#05,#09,#03,#0E
db #07,#00,#00,#04,#01,#DF,#F6,#F0,#F6,#F2,#F1,#FA,#F6,#F2,#F6,#F0,#F0,#E3,#02,#02,#00,#08,#02,#0F,#2E
db #26,#00,#08,#01,#5D,#FE,#F2,#F2,#F7,#F1,#F0,#F6,#F1,#F0,#F2,#F0,#F1,#08,#00,#00,#05,#02,#0F,#2F,#CE
db #47,#00,#00,#1B,#FE,#F4,#F0,#F6,#F0,#F0,#FE,#F1,#F0,#D6,#F0,#F0,#E7,#00,#00,#02,#08,#03,#0F,#BF,#CC
db #67,#08,#17,#9E,#FC,#F6,#F6,#F6,#F3,#F4,#F6,#F0,#F6,#F1,#F0,#F1,#F9,#02,#09,#04,#00,#0F,#1F,#7F,#8C
db #77,#0B,#3B,#F8,#F0,#F0,#BC,#F2,#F0,#BC,#F0,#F0,#F2,#F0,#F0,#F6,#F0,#08,#02,#01,#07,#0F,#7F,#EF,#00
db #25,#0A,#34,#F0,#F0,#FC,#F2,#F0,#FC,#F0,#F0,#D6,#F1,#F0,#F3,#F8,#F0,#09,#04,#02,#0F,#3F,#BF,#8C,#00
db #31,#8C,#74,#F0,#F8,#FC,#F7,#F0,#FC,#F2,#F6,#F1,#F0,#F1,#FC,#F0,#C6,#04,#01,#07,#0F,#DF,#EF,#00,#00
db #12,#8D,#34,#F7,#FC,#F2,#F0,#7C,#F2,#F0,#F4,#F2,#F0,#FF,#F0,#F1,#09,#00,#09,#0F,#3F,#7F,#8C,#00,#00
db #10,#4F,#32,#FF,#F8,#F5,#F8,#F8,#F4,#B4,#F1,#F0,#F3,#F8,#F0,#84,#04,#02,#07,#0F,#FF,#CE,#00,#00,#00
db #11,#C6,#1A,#F0,#F0,#F1,#F8,#F6,#F0,#F4,#F0,#F1,#FC,#F0,#E3,#02,#08,#05,#0F,#7F,#FF,#08,#00,#00,#00
db #00,#C7,#15,#F0,#C3,#F8,#F4,#F0,#FC,#F2,#F0,#FE,#F0,#F0,#08,#08,#01,#0F,#3F,#BF,#CE,#00,#00,#00,#00
db #00,#EF,#09,#F2,#F3,#F8,#F9,#F8,#F2,#F0,#F3,#F8,#F0,#C6,#06,#00,#07,#0F,#AF,#FF,#00,#00,#00,#00,#00
db #00,#6B,#02,#EF,#F0,#F0,#F0,#F8,#F4,#F0,#FC,#F0,#E3,#00,#08,#05,#0F,#1F,#FF,#8C,#00,#00,#00,#00,#00
db #00,#73,#0D,#F7,#F0,#F3,#F8,#F4,#F0,#F7,#F0,#F0,#8C,#0A,#01,#0B,#0F,#FF,#EF,#00,#00,#00,#00,#00,#00
db #00,#35,#0B,#F0,#F0,#FF,#F0,#F0,#F3,#F8,#F0,#C6,#02,#00,#06,#0F,#7F,#7F,#8C,#00,#00,#00,#00,#00,#00
db #00,#31,#8E,#F8,#F0,#F8,#F0,#F0,#FC,#F0,#F1,#09,#04,#09,#0F,#1F,#5F,#EE,#00,#00,#00,#00,#00,#00,#00
db #00,#12,#8D,#78,#7C,#F0,#F0,#F1,#F0,#F0,#8C,#06,#00,#07,#0F,#7F,#FF,#88,#00,#00,#00,#00,#00,#00,#00
db #00,#10,#CD,#74,#F0,#F0,#E3,#78,#F0,#E3,#06,#08,#0B,#0F,#3F,#DF,#CE,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#11,#C6,#3C,#F0,#F1,#08,#74,#F1,#08,#08,#02,#0F,#0F,#DF,#FF,#08,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#E7,#38,#F0,#86,#05,#3C,#C6,#07,#02,#0B,#0F,#3F,#7F,#CE,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#EF,#16,#E3,#00,#0A,#03,#01,#08,#05,#07,#2F,#FF,#EF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#6B,#1D,#08,#05,#01,#04,#0C,#02,#0B,#0F,#BF,#BF,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#73,#0A,#05,#02,#0A,#07,#02,#0B,#0F,#3F,#DF,#EF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#35,#0D,#00,#08,#01,#08,#01,#07,#0F,#EF,#FF,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#31,#8A,#05,#02,#0F,#02,#0F,#0F,#7F,#BF,#EE,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#32,#8D,#00,#05,#00,#05,#0F,#3F,#DF,#FF,#08,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#10,#CD,#0B,#0E,#0A,#0F,#1F,#DF,#FF,#CE,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#11,#C6,#0D,#00,#05,#0F,#5F,#7F,#FF,#08,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#E6,#0A,#05,#0F,#2F,#FF,#FF,#CC,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#EB,#01,#07,#0F,#BF,#FF,#EF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#6B,#0D,#0F,#5F,#FF,#FF,#8C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#73,#0F,#1F,#7F,#FF,#EF,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#35,#1F,#7F,#FF,#FF,#88,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#31,#DF,#FF,#FF,#E6,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#12,#FF,#FF,#FD,#08,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#10,#FF,#FE,#C6,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#11,#F7,#F9,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#F6,#84,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#6B,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00

sprsysgam   db 25,100,70    ;Game-Grafik
db #BE,#F0,#D3,#F0,#F0,#3E,#F0,#85,#F0,#E1,#74,#F0,#97,#F0,#E1,#74,#F0,#9B,#F0,#E3,#78,#F1,#3E,#F0,#C7
db #10,#F0,#80,#78,#E1,#10,#F0,#88,#78,#C2,#32,#F0,#08,#F8,#C0,#30,#F1,#01,#F0,#C4,#34,#F0,#3E,#F0,#C7
db #11,#F0,#80,#70,#E0,#10,#F0,#88,#78,#C2,#32,#F0,#00,#F8,#C0,#30,#F1,#00,#F0,#84,#34,#F1,#1E,#F0,#C7
db #10,#F0,#80,#78,#E1,#12,#F0,#80,#F8,#E2,#30,#F0,#88,#F0,#E2,#34,#F0,#19,#F0,#C0,#74,#F0,#3E,#F0,#C7
db #3E,#F0,#C3,#F8,#F0,#3C,#F0,#F2,#F0,#F0,#F8,#F0,#D6,#F0,#F0,#F8,#F0,#F6,#F0,#E1,#F8,#F1,#3E,#F0,#C7
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#3E,#F0,#C7
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#3E,#F0,#C7
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#3E,#F0,#C7
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#3E,#F0,#C7
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#3E,#F0,#C7
db #FF,#FF,#F8,#F0,#F0,#3A,#F0,#F0,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F8,#F0,#C2,#74,#F1,#1E,#F0,#C7
db #0F,#0F,#3E,#F0,#E1,#10,#F0,#F1,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#7E,#F0,#C4,#34,#F0,#3E,#F0,#C7
db #0F,#0F,#1F,#F0,#E0,#11,#F0,#C3,#0F,#4F,#0F,#0F,#8F,#4F,#0F,#8F,#4F,#1E,#F0,#C0,#30,#F1,#3E,#F0,#C7
db #FF,#FF,#0F,#F0,#F1,#10,#F0,#C7,#7F,#BF,#FF,#FF,#7F,#BF,#FF,#7F,#BF,#0F,#F0,#C2,#70,#F1,#BE,#F0,#C7
db #F0,#F0,#C7,#F8,#F0,#FC,#F0,#87,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#8F,#F0,#F0,#F0,#F1,#1E,#F0,#C7
db #F0,#F0,#C7,#F8,#F0,#F0,#F0,#87,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#C7,#F0,#F0,#F0,#F0,#3E,#F0,#C7
db #F0,#F0,#C7,#F8,#F0,#F0,#F0,#87,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#87,#F0,#F0,#F0,#F1,#3E,#F0,#C7
db #F0,#F0,#C7,#F8,#F0,#F0,#F0,#87,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#C7,#F8,#F0,#F0,#F0,#3E,#F0,#C7
db #F0,#F0,#C7,#F8,#F0,#F0,#F0,#C7,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#87,#F0,#F0,#F0,#F1,#1E,#F0,#C7
db #F0,#F0,#C7,#F8,#F0,#F0,#F0,#87,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#87,#F0,#F0,#F0,#F0,#1E,#F0,#C7
db #FC,#F0,#C7,#F8,#F1,#16,#F0,#C7,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#1F,#F0,#C2,#34,#F0,#1F,#FF,#8F
db #1E,#F0,#C7,#F8,#E1,#10,#F0,#C7,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#1F,#F0,#C0,#30,#F0,#8F,#0F,#1F
db #3E,#F0,#C7,#F8,#E0,#10,#F0,#E3,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#3E,#F0,#C0,#34,#F0,#C7,#0F,#1E
db #1E,#F0,#C7,#F8,#E1,#12,#F0,#F0,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F8,#F0,#E0,#74,#F0,#F1,#FF,#FC
db #3E,#F0,#C7,#F8,#F0,#F4,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1,#00,#78,#F0
db #1E,#F0,#C7,#F8,#E1,#01,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#8C,#00,#12,#F0
db #3E,#F0,#C7,#F8,#E3,#01,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#08,#00,#01,#F0
db #1E,#F0,#C7,#E9,#69,#0B,#D3,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1,#00,#00,#00,#F8
db #3E,#F0,#C7,#EB,#02,#0A,#05,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1,#00,#00,#00,#78
db #1E,#F0,#C7,#CA,#00,#08,#00,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#C4,#00,#00,#34
db #3E,#F0,#C7,#CB,#00,#0A,#01,#78,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#80,#00,#30
db #1E,#F0,#C7,#CA,#09,#01,#02,#78,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E3,#00,#34
db #3E,#F0,#C7,#8C,#04,#00,#08,#34,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E7,#00,#30
db #3E,#F0,#C7,#8C,#01,#04,#02,#34,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F3,#88,#00,#34
db #1E,#F0,#C7,#0C,#08,#00,#08,#34,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#C4,#00,#00,#34
db #3E,#F0,#C7,#8C,#02,#02,#02,#34,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1,#00,#00,#00,#78
db #3E,#F0,#C7,#8C,#00,#08,#00,#34,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1,#00,#00,#00,#78
db #3E,#F0,#C7,#89,#04,#01,#01,#34,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#08,#00,#11,#F0
db #1E,#F0,#C7,#8C,#00,#0C,#0A,#34,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#8E,#00,#16,#F0
db #3E,#F0,#C7,#9C,#85,#AC,#25,#34,#F0,#F0,#F0,#F0,#F2,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E3,#0F,#7C,#F0
db #3E,#F0,#C7,#BE,#C5,#0A,#7C,#BC,#F0,#F0,#F0,#F0,#88,#F0,#F0,#F3,#FF,#FF,#FF,#FF,#FF,#AF,#0F,#EF,#FF
db #3E,#F0,#C7,#FC,#E3,#11,#F8,#F5,#0F,#3E,#F0,#F0,#08,#78,#F0,#8F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #1E,#F0,#C7,#F8,#E1,#10,#F0,#C7,#0F,#0F,#F8,#F0,#08,#F8,#F1,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#8F,#0F,#0F
db #3E,#F0,#C7,#F8,#F1,#3E,#F0,#C7,#4F,#8F,#78,#F0,#8D,#F0,#E1,#3F,#FA,#FA,#FA,#FA,#FA,#FA,#FD,#F5,#F5
db #3E,#F0,#C7,#F8,#F0,#F4,#F0,#8F,#F8,#C7,#7C,#F0,#F0,#F0,#E1,#3C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #3E,#F0,#C7,#F8,#F0,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#E1,#3C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #1E,#F0,#C7,#F8,#F0,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#E1,#BC,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #3E,#F0,#C7,#F8,#F0,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#E1,#3C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #3E,#F0,#C7,#F8,#F0,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#E1,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #1F,#F0,#87,#F8,#F0,#7C,#F0,#9F,#F0,#E3,#7C,#F0,#97,#F0,#E1,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #8F,#2F,#0F,#F0,#E1,#12,#F0,#9F,#F0,#E3,#7C,#F0,#08,#F8,#F1,#0F,#FF,#FF,#DF,#FF,#FF,#FF,#DE,#F0,#D3
db #87,#0F,#1F,#F0,#E0,#10,#F0,#9F,#F0,#E3,#7C,#F0,#08,#78,#F1,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#1E,#F0,#C3
db #E7,#4F,#7E,#F0,#E0,#10,#F0,#9F,#F0,#E3,#FC,#F0,#08,#F8,#F0,#97,#0F,#0F,#0F,#0F,#0F,#0F,#1E,#F0,#C3
db #F0,#F0,#F7,#FC,#F0,#3C,#F0,#DF,#F0,#E3,#7C,#F0,#D6,#F0,#F0,#F1,#FB,#FB,#FA,#F8,#F8,#F1,#1E,#F0,#C3
db #F0,#F1,#88,#37,#F0,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#9F,#F0,#C3
db #F0,#E2,#00,#00,#F0,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#1E,#F0,#C3
db #F0,#C6,#00,#02,#70,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#9E,#F0,#C3
db #F0,#8D,#00,#09,#32,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#1E,#F0,#C3
db #F0,#08,#0D,#00,#1A,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#9F,#F0,#C3
db #FC,#8C,#11,#08,#3A,#3C,#F0,#9F,#F0,#F3,#7C,#F0,#96,#F0,#E3,#78,#F0,#B6,#F0,#E1,#74,#F0,#1E,#F0,#C3
db #13,#E2,#10,#C4,#13,#10,#F0,#BF,#F0,#E3,#7C,#F0,#00,#F0,#C0,#34,#F1,#11,#F0,#C2,#30,#F0,#9E,#F0,#C3
db #01,#CA,#14,#84,#08,#11,#F0,#9F,#F0,#E3,#7C,#F0,#00,#F0,#C4,#34,#E1,#01,#F0,#C0,#30,#F0,#1E,#F0,#C3
db #01,#04,#08,#09,#01,#12,#F0,#9F,#F0,#E3,#7C,#F0,#09,#F0,#C0,#34,#E1,#11,#F0,#E2,#34,#F0,#9F,#F0,#C3
db #2C,#01,#00,#02,#01,#BE,#F0,#9F,#F0,#E3,#7C,#F0,#96,#F0,#E1,#F8,#F0,#1E,#F0,#F0,#F8,#F0,#1E,#F0,#C3
db #E1,#00,#00,#00,#01,#F0,#F0,#9F,#F0,#E3,#FC,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#9E,#F0,#C3
db #E0,#00,#00,#00,#01,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#1E,#F0,#C3
db #E1,#00,#00,#00,#01,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#9E,#F0,#C3
db #E0,#06,#03,#08,#09,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#1F,#F0,#C3
db #E1,#67,#30,#89,#C5,#F0,#F0,#9F,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#9E,#F0,#C3
db #E1,#F1,#34,#9A,#E3,#F0,#F0,#DF,#F0,#E3,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1,#7C,#F0,#1E,#F0,#C3

sprsys128   db 30,120,41    ;CPC 6128
db #7D,#F0,#F3,#FF,#FF,#F0,#F8,#FA,#FB,#FF,#FB,#F7,#F7,#F7,#7F,#0F,#2F,#6F,#3F,#FF,#7F,#FF,#FF,#FF,#FF,#FF,#FF,#FD,#FF,#04
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#F7,#F2,#FB,#FF,#FF,#FF,#DF,#FF,#FF,#FD,#F5,#F0,#F7,#FF,#FA,#F0,#F0,#F0,#F0,#E1
db #F0,#F0,#F0,#F0,#F0,#F0,#F6,#FF,#FF,#FF,#FF,#6F,#8F,#0F,#0F,#0F,#0F,#0F,#0F,#1F,#1F,#7F,#7F,#FF,#FF,#FD,#F0,#F0,#F0,#E1
db #F0,#E1,#77,#FF,#FF,#BF,#0E,#7F,#BF,#F7,#FF,#DF,#2F,#0F,#0F,#0E,#0A,#0A,#0F,#0F,#0F,#4F,#DF,#FF,#FD,#F2,#F0,#F0,#F0,#E1
db #F0,#F1,#99,#4F,#8F,#0F,#0F,#0F,#3E,#FF,#FF,#4F,#0F,#0F,#0F,#05,#0F,#05,#05,#1F,#0E,#7F,#AF,#FF,#FF,#F8,#F8,#F0,#F0,#E1
db #F0,#F0,#F5,#F0,#F2,#FE,#FF,#FB,#FB,#FF,#FF,#AF,#0F,#0F,#0D,#0A,#00,#00,#00,#0F,#1F,#BF,#5F,#7F,#FF,#FE,#F4,#F0,#F0,#E1
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F7,#FF,#FF,#EF,#AF,#4F,#9F,#6F,#FF,#7F,#FF,#FF,#FF,#F7,#FF,#F5,#FA,#F8,#F0,#E1
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#FB,#FF,#FF,#7F,#4F,#0F,#0D,#00,#00,#00,#00,#00,#09,#0F,#AF,#FF,#FF,#FF,#FF,#FF,#F6,#F8,#E1
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F5,#F7,#FF,#CF,#0F,#0F,#0A,#00,#00,#00,#00,#00,#02,#0F,#0F,#AF,#3F,#7F,#FF,#FE,#FF,#F7,#F1
db #F0,#F0,#F0,#F0,#F0,#F0,#F2,#FA,#FB,#FF,#FF,#4F,#0F,#0A,#00,#00,#00,#00,#00,#06,#07,#4F,#1F,#3F,#BF,#FF,#FB,#C7,#8F,#E9
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#FF,#FF,#DF,#5F,#0F,#0D,#08,#00,#00,#00,#0F,#0F,#0F,#BF,#9F,#3F,#7F,#FF,#FF,#FB,#FC,#E9
db #F0,#F0,#F0,#F0,#F0,#F0,#F9,#F6,#FA,#FF,#FF,#AF,#8F,#0F,#0F,#08,#00,#03,#0F,#0F,#1F,#2F,#2F,#3F,#5F,#FF,#FD,#F6,#F1,#F1
db #F0,#F0,#FC,#FE,#FF,#FF,#DF,#EF,#CF,#6F,#2F,#3F,#1F,#0F,#0D,#0C,#00,#04,#07,#0F,#1F,#5F,#0F,#BF,#7F,#FF,#0F,#2F,#FD,#F5
db #F0,#E1,#0B,#05,#01,#09,#08,#08,#04,#04,#22,#02,#01,#01,#08,#08,#04,#04,#02,#03,#01,#01,#0F,#3F,#1F,#7F,#1F,#5F,#F6,#F8
db #F0,#E1,#0F,#13,#03,#02,#0A,#08,#0C,#04,#02,#03,#01,#01,#08,#08,#04,#04,#02,#03,#11,#01,#8F,#2F,#8F,#8F,#FF,#FF,#FF,#FC
db #F0,#F1,#07,#0F,#0F,#09,#89,#0C,#0C,#06,#06,#02,#01,#01,#08,#08,#04,#06,#02,#02,#01,#01,#0F,#BF,#2F,#1F,#2F,#FF,#FF,#FC
db #F0,#F0,#FF,#FF,#EF,#EF,#DF,#5F,#6F,#8F,#0F,#1F,#1F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#1F,#0F,#3F,#6F,#06,#0F,#0F,#3F,#F8
db #F0,#F1,#0F,#0F,#0E,#0E,#2A,#07,#03,#01,#08,#08,#0C,#06,#02,#02,#01,#00,#02,#03,#13,#09,#0F,#BF,#2F,#01,#01,#07,#CF,#FA
db #F0,#E1,#06,#0D,#07,#0E,#0A,#0B,#01,#01,#08,#08,#04,#04,#06,#03,#01,#00,#02,#03,#01,#01,#0F,#FF,#4F,#0C,#0A,#0B,#4F,#F8
db #F0,#F1,#05,#4D,#0C,#0A,#02,#03,#01,#01,#08,#08,#0C,#04,#02,#02,#01,#00,#02,#02,#11,#01,#5F,#FF,#2F,#0A,#0D,#0F,#8F,#FA
db #F0,#F0,#EF,#4F,#2F,#2F,#2F,#0F,#1F,#0B,#0B,#0D,#0C,#0E,#06,#03,#03,#00,#22,#03,#03,#09,#BF,#BF,#4F,#0F,#BF,#DF,#BF,#FC
db #F0,#F1,#3F,#AF,#FF,#1F,#1F,#0F,#8F,#8F,#CF,#0F,#2F,#1F,#0F,#0F,#0D,#08,#03,#0F,#0F,#3F,#1F,#FF,#0F,#5F,#5F,#7F,#FF,#F8
db #F0,#F1,#07,#07,#03,#03,#01,#01,#08,#08,#04,#04,#02,#02,#11,#01,#08,#08,#06,#03,#11,#01,#FF,#FD,#7F,#FF,#FF,#FF,#FD,#F4
db #F0,#F1,#07,#26,#0F,#07,#07,#00,#0A,#08,#0C,#04,#02,#03,#01,#00,#08,#08,#02,#03,#01,#01,#5F,#FF,#AF,#BF,#BF,#FF,#FB,#FC
db #F0,#F1,#0F,#0F,#0B,#15,#01,#09,#08,#0C,#0C,#06,#22,#03,#11,#01,#08,#0C,#02,#03,#11,#01,#FF,#FD,#5F,#5F,#06,#0B,#FE,#F8
db #F0,#F0,#FF,#FF,#FF,#FF,#FF,#EF,#DF,#8F,#4F,#4F,#4F,#0F,#0F,#0F,#0F,#0F,#2F,#0F,#1F,#1F,#7F,#FF,#4E,#3F,#0F,#EF,#FF,#F4
db #F0,#F1,#0F,#0F,#0D,#0C,#0E,#0E,#26,#07,#13,#09,#09,#0C,#4C,#06,#06,#00,#07,#23,#1B,#1D,#FF,#FD,#CF,#0F,#3F,#EF,#FF,#F8
db #F0,#F1,#03,#09,#0F,#0D,#04,#06,#0A,#03,#01,#01,#08,#08,#0C,#04,#02,#00,#02,#22,#01,#01,#FF,#F5,#5F,#3F,#CF,#FF,#9E,#F4
db #F0,#F1,#0D,#06,#8C,#0D,#0D,#06,#22,#03,#03,#01,#08,#08,#04,#06,#02,#00,#22,#03,#11,#01,#FE,#FD,#DF,#3F,#4F,#7F,#FF,#F8
db #F0,#F0,#FF,#FF,#7F,#4F,#6F,#2F,#2F,#0F,#1F,#0F,#0B,#0D,#0C,#06,#06,#00,#06,#03,#03,#09,#FE,#F5,#DF,#3F,#7F,#FF,#9F,#F8
db #F0,#F0,#5F,#5F,#CF,#1F,#8F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#8F,#0F,#0F,#BF,#7F,#BF,#BF,#FD,#FD,#DF,#1F,#CF,#FF,#FF,#F4
db #F0,#F1,#07,#0D,#0D,#05,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#88,#00,#00,#06,#03,#03,#11,#FA,#F5,#DF,#3F,#EF,#FF,#BE,#F8
db #F0,#F1,#0F,#0D,#0D,#0D,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#08,#00,#00,#22,#03,#11,#15,#F9,#F4,#DF,#3F,#6F,#FF,#FF,#F8
db #F0,#F0,#0F,#0F,#CF,#0B,#8F,#0D,#04,#00,#00,#00,#00,#00,#00,#88,#00,#00,#06,#03,#03,#11,#F8,#FC,#FF,#3F,#EF,#FF,#FF,#FC
db #F0,#F0,#F0,#F0,#F9,#F2,#FB,#FD,#FD,#F7,#FF,#FF,#FF,#5F,#5F,#CF,#0F,#0F,#7F,#3F,#3F,#BF,#FA,#F4,#CF,#FF,#FF,#FF,#FF,#FC
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#FF,#FF,#EF,#AF,#0F,#0F,#0F,#AF,#FF,#FF,#FF,#F0,#F8,#BF,#FF,#FE,#FB,#FA,#F8
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F5,#F7,#FF,#FF,#FF,#DF,#0F,#0F,#0F,#0F,#1F,#5F,#FF,#FF,#F5,#F4,#8C,#0F,#4F,#3F,#2F,#FC
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#F0,#F8,#FA,#FF,#FF,#FF,#FF,#AF,#0F,#FF,#FF,#FF,#FF,#FD,#F2,#F4,#CF,#0F,#FF,#FF,#FF,#F8
db #F0,#F0,#F0,#F0,#F0,#F0,#F1,#F1,#F5,#F3,#F5,#FA,#FF,#FF,#DF,#FF,#FF,#FF,#FF,#FF,#FF,#F6,#F8,#F0,#FF,#FF,#FF,#FF,#FD,#F4
db #F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#FA,#FA,#FD,#FD,#F0,#F0,#FB,#FD,#F4,#F0,#F0,#F0,#F5,#F0,#F0,#F0,#F0,#F0
db #FD,#FB,#FD,#FD,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#DF,#DF,#0F,#5F,#FF,#FF,#FF,#FF,#FF,#FC,#F0,#F0,#F0,#F0,#F0,#F1

sprsys664   db 30,120,41    ;CPC 664
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F1,#FF,#FF,#FF,#FF,#DF,#4F,#0F,#0F,#0F,#0F,#1F,#CF,#0F,#5F,#4F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F7
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F5,#FD,#F5,#FB,#FF,#FF,#FF,#FF,#F5,#F0,#F5,#FD,#FF,#F8,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#FA,#FB,#FF,#FF,#FF,#FF,#5F,#2F,#8F,#0F,#2F,#7F,#7F,#FF,#FF,#FF,#FD,#F6,#F8,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F1,#F1,#F6,#FB,#FF,#FF,#EF,#AF,#0F,#0F,#0F,#0F,#0F,#0F,#2F,#1F,#FF,#FF,#FD,#F5,#F5,#F4,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#FB,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FD,#FD,#F0,#F2,#F2,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#FA,#F4,#F5,#F7,#FF,#0F,#0F,#0F,#3F,#FF,#F9,#F2,#F0,#F0,#F0,#F1,#F4,#F9,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F5,#FB,#F7,#FF,#FF,#FF,#4F,#0F,#08,#00,#00,#00,#00,#01,#0F,#1F,#5F,#5F,#FF,#FC,#F2,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F4,#FA,#FF,#FF,#4F,#0F,#0C,#00,#00,#00,#00,#00,#07,#00,#01,#37,#FF,#FF,#FD,#FC,#FA,#F8,#F0,#F1
db #F0,#F0,#F2,#F7,#FF,#FD,#F3,#F5,#FB,#EF,#9F,#0F,#02,#00,#00,#00,#00,#01,#06,#00,#00,#07,#FF,#FF,#FD,#87,#6F,#7E,#FF,#F0
db #F0,#F0,#C7,#5F,#0F,#79,#FF,#FF,#2F,#0F,#0F,#02,#00,#00,#00,#00,#00,#00,#02,#0C,#00,#05,#FF,#FF,#FD,#8F,#CF,#BF,#BF,#F9
db #F0,#F0,#F1,#FF,#FF,#FD,#1F,#0F,#0B,#09,#00,#00,#00,#00,#00,#00,#00,#00,#02,#02,#01,#09,#BF,#FF,#FD,#8F,#5F,#D3,#FC,#78
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#FA,#FB,#FF,#DF,#0F,#0D,#00,#00,#00,#00,#00,#22,#03,#0F,#01,#FF,#FF,#FD,#97,#EF,#D7,#FD,#78
db #F0,#F0,#F0,#F0,#F0,#F7,#FF,#F5,#FF,#FF,#FF,#4F,#0F,#0F,#00,#00,#00,#00,#02,#01,#03,#01,#FF,#FF,#FD,#9E,#C3,#3E,#BF,#F8
db #F0,#F0,#F0,#F0,#F1,#F1,#F5,#F6,#FB,#FF,#FF,#AF,#0F,#0A,#08,#00,#00,#00,#2A,#03,#01,#01,#FF,#FF,#FD,#F7,#FF,#FE,#FF,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F8,#F9,#F4,#FF,#FF,#DF,#0F,#0F,#0B,#00,#01,#0F,#06,#01,#03,#01,#BF,#FF,#FD,#8F,#1B,#0F,#9F,#7C
db #F0,#F0,#D7,#8F,#8F,#8F,#8F,#8F,#8F,#8F,#8F,#8F,#8F,#8D,#0C,#0C,#06,#0F,#2A,#13,#0F,#01,#FF,#FF,#F9,#FF,#FF,#FF,#FF,#F8
db #F0,#F0,#87,#0B,#09,#09,#09,#09,#08,#88,#88,#08,#08,#08,#08,#0C,#08,#03,#06,#04,#01,#19,#FF,#FF,#FD,#F7,#EF,#8F,#F8,#F0
db #F0,#F0,#83,#09,#0A,#0A,#88,#88,#88,#88,#08,#88,#88,#08,#08,#08,#0C,#03,#0E,#08,#00,#0D,#FF,#FF,#F9,#DF,#FF,#FD,#FE,#F0
db #F0,#F0,#F7,#FF,#DF,#DF,#DF,#CF,#8F,#8F,#8F,#8F,#8D,#8D,#8D,#8C,#0C,#03,#07,#00,#00,#17,#FF,#FF,#FD,#FF,#FF,#FD,#FB,#F8
db #F0,#F0,#C7,#2F,#2F,#2F,#2F,#2F,#2F,#2F,#2F,#0F,#2F,#27,#2F,#07,#03,#2F,#1F,#01,#01,#33,#FF,#FF,#F9,#E7,#FB,#FE,#FF,#F0
db #F0,#F0,#85,#0E,#0A,#0A,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#00,#03,#2F,#03,#03,#33,#FF,#FF,#F9,#EF,#FE,#FF,#FB,#F8
db #F0,#F0,#86,#2A,#0E,#06,#06,#06,#22,#22,#22,#22,#02,#02,#02,#02,#00,#03,#0F,#03,#03,#13,#FF,#FF,#F9,#EF,#FF,#FE,#FB,#F8
db #F0,#F0,#F7,#FF,#7F,#7F,#3F,#2F,#2F,#2F,#2F,#2F,#27,#27,#27,#07,#00,#23,#2F,#03,#03,#33,#FF,#FF,#F9,#EF,#7F,#BF,#FF,#F0
db #F0,#F0,#C7,#1F,#0F,#1F,#0F,#1F,#1F,#1B,#0F,#0B,#0F,#0F,#0B,#0D,#00,#03,#2F,#2F,#2F,#3F,#FF,#FF,#F9,#EF,#FB,#FC,#FB,#F8
db #F0,#F0,#C5,#0D,#15,#01,#01,#01,#01,#01,#01,#01,#01,#01,#01,#01,#00,#13,#2F,#03,#02,#33,#FF,#FF,#F9,#EF,#7F,#BF,#FF,#FC
db #F0,#F0,#87,#1B,#03,#15,#03,#11,#11,#01,#11,#01,#01,#01,#01,#01,#00,#23,#AF,#02,#03,#33,#FF,#FF,#F9,#FF,#FD,#F4,#F2,#F0
db #F0,#F0,#E3,#FF,#FF,#BF,#9F,#BF,#9F,#1F,#1F,#1F,#1F,#1B,#1B,#0B,#08,#3B,#2F,#23,#03,#33,#FF,#FF,#F9,#F8,#E3,#0F,#F8,#F0
db #F0,#F0,#C7,#0F,#4F,#4F,#4F,#4E,#4F,#4F,#4E,#4F,#0E,#4F,#4E,#4E,#0F,#2F,#6F,#2F,#2F,#7F,#FF,#FF,#F9,#8F,#5F,#FB,#FB,#FC
db #F0,#F0,#C5,#0E,#0E,#05,#04,#05,#04,#04,#04,#04,#04,#04,#04,#04,#00,#33,#AF,#02,#03,#33,#FF,#FF,#F9,#CC,#1B,#FE,#FE,#F8
db #F0,#F0,#87,#0F,#0E,#4C,#0C,#4C,#0C,#44,#44,#44,#44,#04,#04,#04,#00,#23,#EF,#03,#03,#33,#FF,#FF,#F9,#8F,#0F,#2F,#FF,#FC
db #F0,#F0,#F1,#FF,#FB,#FF,#EB,#EF,#6F,#4F,#4F,#4F,#4F,#4F,#4F,#6E,#09,#37,#EF,#23,#03,#37,#FF,#FF,#F1,#8F,#0F,#1F,#FF,#FC
db #F0,#F0,#F0,#F0,#F0,#E3,#9F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#4F,#3F,#FF,#EF,#EF,#2F,#3F,#BF,#FF,#FF,#F9,#CF,#0F,#AF,#FF,#FC
db #F0,#F0,#F0,#F0,#F0,#C2,#00,#00,#00,#00,#00,#00,#00,#00,#04,#67,#0F,#1F,#EF,#03,#03,#33,#FF,#FF,#F1,#CF,#2F,#5F,#7F,#FC
db #F0,#F0,#F0,#F0,#F0,#C2,#00,#00,#00,#00,#00,#00,#00,#00,#46,#47,#0F,#1F,#6F,#03,#03,#32,#FF,#FF,#F9,#FD,#FF,#FF,#F9,#FC
db #F0,#F0,#F0,#F0,#F0,#F3,#FF,#FF,#FF,#4F,#0F,#0F,#0F,#0F,#4E,#6F,#DF,#7F,#FF,#2F,#3F,#3F,#FF,#FF,#F1,#FD,#F5,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#FF,#FF,#7F,#DF,#BF,#DF,#FF,#FE,#FF,#FB,#FF,#FF,#F9,#FA,#FA,#FA,#FA,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#FF,#FD,#F0,#F0,#F1
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0

sprsys464   db 30,120,41    ;CPC 464
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F1,#FF,#FF,#FF,#FF,#FF,#EF,#AF,#9F,#0F,#0F,#0F,#0F,#0F,#0F,#1F,#2F,#AF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F5
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#FB,#FF,#F7,#FF,#FF,#FF,#FF,#FF,#CF,#DF,#FF,#FF,#FF,#7F,#EF,#AF,#AF,#FF,#F8,#F8,#F8,#F1
db #F0,#F0,#F0,#F0,#F0,#F5,#FF,#FF,#FF,#FF,#EF,#5F,#0F,#0F,#0F,#05,#05,#06,#05,#7F,#8F,#0F,#0F,#0F,#BF,#7F,#FF,#FF,#F4,#F4
db #F0,#F0,#F0,#F0,#F0,#FB,#F5,#FF,#FF,#FF,#AF,#8F,#0F,#0F,#0A,#08,#00,#00,#09,#4B,#8E,#0F,#0F,#7F,#FF,#FF,#FF,#FE,#FD,#F9
db #F0,#F0,#F0,#F0,#F1,#F5,#FB,#F7,#FF,#EF,#DF,#4F,#0F,#0E,#0D,#05,#04,#0B,#02,#4A,#8F,#05,#2F,#9F,#6F,#FF,#FF,#FB,#F4,#F0
db #F0,#F0,#F0,#FB,#FF,#FF,#FF,#FF,#AF,#9F,#0F,#0F,#0F,#05,#00,#00,#02,#04,#01,#7B,#8D,#0B,#0F,#5F,#7F,#7F,#FF,#FD,#FB,#FD
db #F0,#F0,#FF,#FF,#FF,#FF,#FF,#2F,#4F,#0F,#0F,#0F,#0A,#00,#00,#00,#06,#00,#0F,#FC,#EF,#0D,#2F,#BF,#FF,#FF,#FF,#F7,#F4,#F0
db #F0,#F1,#3F,#0F,#1F,#FF,#AF,#CF,#9F,#0F,#0F,#0C,#04,#08,#00,#00,#00,#00,#4B,#8C,#6F,#CF,#3F,#FF,#FF,#FF,#FA,#FC,#F5,#FE
db #F0,#F0,#8D,#4F,#1F,#8E,#0F,#0D,#06,#04,#00,#00,#00,#00,#00,#00,#00,#00,#4C,#8C,#46,#0F,#0E,#0F,#0F,#0F,#AF,#FF,#FF,#F0
db #F0,#F1,#FF,#FF,#FF,#DF,#0F,#2F,#0F,#0F,#0D,#0A,#00,#00,#00,#00,#00,#00,#4B,#8C,#7F,#8D,#0E,#05,#0E,#0F,#0F,#0F,#FF,#FC
db #F0,#F0,#F0,#F2,#FF,#FF,#F7,#FF,#FF,#EF,#AF,#9F,#0F,#0F,#0D,#00,#00,#04,#7D,#EF,#FE,#8E,#0E,#00,#00,#00,#00,#00,#7F,#F2
db #F0,#F0,#F0,#F0,#F0,#F2,#FE,#FF,#FF,#FF,#DF,#2F,#8F,#0F,#0A,#0D,#05,#08,#00,#5F,#0E,#0D,#06,#08,#00,#00,#00,#00,#7F,#FC
db #F0,#F1,#FE,#F0,#F0,#F0,#F0,#F0,#F1,#F1,#F9,#F3,#F9,#FF,#FF,#EF,#0A,#08,#00,#4A,#0C,#02,#0E,#08,#00,#00,#00,#00,#DF,#F0
db #F0,#E3,#3F,#F9,#E9,#E9,#E9,#E9,#EB,#EB,#EB,#6B,#6D,#6D,#6D,#2E,#00,#08,#00,#4B,#0C,#09,#04,#05,#01,#0F,#0F,#4F,#7F,#FC
db #F0,#E2,#3F,#F1,#E1,#E9,#E9,#EB,#E9,#EA,#6B,#6A,#6B,#6F,#6F,#6E,#00,#0C,#00,#7F,#8C,#04,#04,#08,#04,#0F,#07,#0F,#7F,#FA
db #F0,#F1,#FE,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F8,#FA,#FA,#EF,#0A,#08,#00,#05,#09,#0C,#0A,#00,#06,#0F,#27,#4F,#5F,#FA
db #F0,#F3,#FF,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#FA,#FF,#FE,#FF,#8F,#0F,#08,#57,#6F,#FF,#88,#04,#09,#0F,#0F,#0F,#4F,#1F,#F8
db #F0,#E2,#0D,#FE,#B6,#B4,#B6,#B6,#B6,#BE,#BE,#9E,#9E,#97,#97,#80,#00,#00,#4F,#CF,#4F,#0C,#02,#0F,#07,#0F,#0F,#0F,#5F,#F6
db #F0,#E2,#0D,#BE,#B6,#B6,#BE,#BE,#BE,#9A,#BE,#9A,#9B,#9D,#95,#88,#00,#08,#4F,#CE,#CA,#0C,#05,#05,#0F,#0F,#2F,#BF,#FF,#F8
db #F0,#F1,#FF,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F6,#F6,#F6,#F6,#FF,#80,#00,#08,#7F,#FF,#FF,#8C,#00,#0F,#0F,#0D,#1F,#6F,#BF,#FA
db #F0,#F1,#FF,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F8,#F9,#FD,#FF,#CC,#00,#08,#77,#FF,#FE,#8C,#07,#0F,#0F,#0C,#6F,#DF,#FF,#F8
db #F0,#E2,#0E,#7E,#F3,#D3,#D3,#D3,#D7,#D7,#D7,#D7,#C7,#C7,#CB,#CC,#00,#08,#4F,#CF,#CB,#0C,#00,#00,#00,#00,#00,#00,#13,#FC
db #F0,#E2,#0E,#5F,#D3,#D3,#D7,#D5,#C5,#87,#C5,#C5,#CD,#CD,#CE,#CC,#00,#00,#4E,#CE,#4A,#0C,#0A,#00,#00,#00,#00,#00,#11,#F2
db #F0,#F1,#FF,#F8,#F0,#F0,#F0,#F0,#F0,#F2,#F7,#F7,#F7,#FB,#EF,#CC,#00,#08,#5F,#EF,#EF,#0D,#03,#0F,#0F,#2F,#FF,#FF,#FF,#FC
db #F0,#F1,#FF,#FE,#F0,#F0,#F0,#F0,#F0,#F1,#F0,#F1,#F7,#F7,#FF,#AF,#1F,#08,#77,#FF,#FC,#86,#0A,#0B,#0F,#4F,#0F,#5F,#3F,#F2
db #F0,#E2,#0E,#17,#F0,#F8,#F8,#FD,#7D,#FD,#FD,#7D,#FD,#7E,#FF,#00,#00,#08,#6F,#DF,#EF,#8D,#04,#00,#01,#0F,#0F,#0F,#0F,#F8
db #F0,#E2,#07,#13,#79,#7D,#7D,#7D,#65,#35,#35,#35,#3F,#37,#37,#00,#00,#0C,#4E,#CE,#4A,#0D,#04,#00,#00,#0F,#0F,#2F,#1F,#F6
db #F0,#F3,#EF,#FE,#F0,#F0,#F0,#F8,#FC,#F9,#FD,#FD,#7D,#3F,#BF,#00,#00,#08,#4F,#CF,#4B,#0E,#0C,#00,#01,#0B,#0F,#0F,#1F,#FC
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#FA,#F7,#F3,#EF,#0E,#0B,#08,#7F,#FF,#FF,#8D,#02,#00,#00,#0D,#00,#02,#03,#F4
db #F0,#F0,#F0,#F1,#F6,#F0,#FA,#FF,#FF,#FF,#FF,#FF,#FF,#FD,#01,#0A,#00,#00,#7F,#FF,#8E,#0C,#0C,#00,#01,#0F,#05,#0F,#1F,#FA
db #F0,#F0,#F0,#F0,#F4,#FF,#FF,#FF,#FF,#AF,#0F,#0F,#0F,#3F,#01,#0D,#04,#00,#4E,#EF,#4C,#04,#07,#2F,#AF,#BF,#FF,#FF,#FF,#FE
db #F0,#F0,#F0,#F0,#F8,#F0,#F0,#F0,#F5,#FB,#F5,#FF,#FF,#BF,#11,#08,#00,#00,#4B,#CF,#8C,#04,#07,#9F,#F2,#F0,#F4,#F0,#F1,#F8
db #F0,#F0,#F0,#F0,#F2,#F0,#F1,#F7,#FA,#F5,#F6,#FB,#FF,#F9,#0F,#08,#00,#00,#47,#6F,#8E,#0C,#1B,#11,#9E,#9E,#9E,#9E,#F3,#FE
db #F0,#F0,#F0,#F0,#F1,#F7,#FF,#FF,#EF,#DF,#4F,#0F,#0F,#0F,#0F,#02,#00,#00,#00,#00,#07,#08,#1F,#18,#9E,#9E,#BE,#BE,#FF,#FA
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#FF,#FF,#FF,#EF,#8F,#0F,#0E,#0C,#00,#00,#00,#01,#00,#01,#17,#FE,#F0,#F0,#F0,#F0,#F3,#F8
db #F0,#F0,#F0,#F0,#F7,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#AF,#9F,#1F,#4F,#0F,#1F,#5F,#7F,#FF,#FF,#FF,#FF,#FF,#BF,#FF,#FF,#F1
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0

;### INFO-FENSTER #############################################################

prgmsginf  dw prgmsginf1,4*1+2,prgmsginf2,4*1+2,prgmsginf3,4*1+2,prgicnbig

;### HAUPT-FENSTER ############################################################

prgwindat  dw #0501,0,-1,-1,320,186,0,0,320,186,320,186,320,186,prgicnsml,prgwintit,0,0
prgwindat1 dw prgwingrp0,0,0:ds 136+14

prgwingrp0 db 10,0:dw prgwinobj0,0,0,0,0,0,0         ;*** LEER-SCREEN
prgwinobj0
dw     00,255*256+00,1         ,0,0,1000,1000,0     ;00=Hintergrund
dw     00,255*256+08,sprsyslog ,034, 08,252,13,0    ;01=Grafik Logo
dw     00,255*256+01,sysselobj5,004,172,208,08,0    ;02=Text Subtitel
dw     00,255*256+00,0         ,216,168, 32,14,0    ;03=Hintergund Help
dw     00,255*256+16,prgbutmsc1,217,169, 30,12,0    ;04=Button Help
dw     00,255*256+00,0         ,250,168, 33,14,0    ;05=Hintergund About
dw prginf,255*256+16,prgbutmsc2,251,169, 31,12,0    ;06=Button About
dw     00,255*256+00,0         ,285,168, 32,14,0    ;07=Hintergund Exit
dw prgend,255*256+16,prgbutmsc3,286,169, 30,12,0    ;08=Button Exit
dw     00,255*256+01,sysselobj4,004,162,208,08,0    ;09=Text Anleitung


prgwingrpa db 19,0:dw prgwinobja,0,0,0,0,0,0        ;*** CORE AUSWAHL
prgwinobja
dw     00,255*256+00,1         ,0,0,1000,1000,0     ;00=Hintergrund
dw     00,255*256+08,sprsyslog ,034, 08,252,13,0    ;01=Grafik Logo
dw     00,255*256+01,sysselobj5,004,172,208,08,0    ;02=Text Subtitel
dw     00,255*256+00,0         ,216,168, 32,14,0    ;03=Hintergund Help
dw     00,255*256+16,prgbutmsc1,217,169, 30,12,0    ;04=Button Help
dw     00,255*256+00,0         ,250,168, 33,14,0    ;05=Hintergund About
dw prginf,255*256+16,prgbutmsc2,251,169, 31,12,0    ;06=Button About
dw     00,255*256+00,0         ,285,168, 32,14,0    ;07=Hintergund Exit
dw prgend,255*256+16,prgbutmsc3,286,169, 30,12,0    ;08=Button Exit

prgwinobj1
dw     00,255*256+02,1+4       ,108, 40,104,74,0    ;09=Rahmen Passiv
dw     00,255*256+02,0+8       ,108, 40,104,74,0    ;10=Rahmen Aktiv

dw     00,255*256+01,sysselobj0,004, 30,312,08,0    ;11=Text Titel
dw sysc64,255*256+08,sprsysc64 ,004, 42,100,70,0    ;12=Grafik CPC
dw     00,255*256+01,sysselobj1,004,117,100,08,0    ;13=  Text CPC
dw syscpc,255*256+08,sprsyscpc ,110, 42,100,70,0    ;14=Grafik C64
dw     00,255*256+01,sysselobj2,110,117,100,08,0    ;15=  Text C64
dw sysgam,255*256+08,sprsysgam ,216, 42,100,70,0    ;16=Grafik Games
dw     00,255*256+01,sysselobj3,216,117,100,08,0    ;17=  Text Games

dw     00,255*256+01,sysselobj4,004,162,208,08,0    ;18=Text Anleitung

sysselobj0  dw sysseltxt0,3+0+512+128
sysselobj1  dw sysseltxt1,3+0+512+128
sysselobj2  dw sysseltxt2,3+0+512+128
sysselobj3  dw sysseltxt3,3+0+512+128
sysselobj4  dw sysseltxt4,1+0
sysselobj5  dw sysseltxt5,1+8


prgwingrpb db 23,0:dw prgwinobjb,0,0,0,0,0,13+1     ;*** CPC ROM AUSWAHL
prgwinobjb
dw     00,255*256+00,1         ,0,0,1000,1000,0     ;00=Hintergrund
dw     00,255*256+08,sprsyslog ,034, 08,252,13,0    ;01=Grafik Logo
dw     00,255*256+01,sysselobj5,004,172,208,08,0    ;02=Text Subtitel
dw     00,255*256+00,0         ,216,168, 32,14,0    ;03=Hintergund Help
dw     00,255*256+16,prgbutmsc1,217,169, 30,12,0    ;04=Button Help
dw     00,255*256+00,0         ,250,168, 33,14,0    ;05=Hintergund About
dw prginf,255*256+16,prgbutmsc2,251,169, 31,12,0    ;06=Button About
dw     00,255*256+00,0         ,285,168, 32,14,0    ;07=Hintergund Exit
;dw syscor,255*256+16,prgbutmsc4,286,169, 30,12,0    ;08=Button Exit
dw prgend,255*256+16,prgbutmsc3,286,169, 30,12,0    ;08=Button Exit
dw     00,255*256+01,sysselobj4,004,162,208,08,0    ;09=Text Anleitung

dw     00,255*256+01,sysselobj6,004, 30,312,08,0    ;10=Text Titel
dw     00,255*256+01,syscpcobj2,004, 41,182,08,0    ;11=Text ROM-Liste
dw     00,255*256+02,2+8       ,004, 50,182,98,0    ;12=CPC ROM-Rahmen
dw ctlrom,255*256+41,syscpcobj1,005, 51,180,96,0    ;13=CPC ROM-Liste
dw     00,255*256+01,syscpcobj3,190, 41,126,08,0    ;14=Text Information
dw     00,255*256+02,2+8       ,190, 50,126,98,0    ;15=Rahmen Information

dw     00,255*256+08
prgwinobjb1       dw 0,          193,104,120,41,0   ;16=Grafik Information
dw     00,255*256+01,syscpcdsc0+00,194,54,122,8,0   ;17=Text Information0
dw     00,255*256+01,syscpcdsc0+04,194,62,122,8,0   ;18=Text Information1
dw     00,255*256+01,syscpcdsc0+08,194,70,122,8,0   ;19=Text Information2
dw     00,255*256+01,syscpcdsc0+12,194,78,122,8,0   ;20=Text Information3
dw     00,255*256+01,syscpcdsc0+16,194,86,122,8,0   ;21=Text Information4
dw     00,255*256+01,syscpcdsc0+20,194,94,122,8,0   ;22=Text Information5

sysselobj6  dw sysseltxt6,3+0+512+128
syscpcobj2  dw syscpctxt2,3+0+512+128
syscpcobj3  dw syscpctxt3,3+0+512+128

syscpcdsc0  dw 00,1+0,00,1+0,00,1+0,00,1+0,00,1+0,00,1+0

syscpcobj1  dw 5,0,syscpclst,0,1,syscpcrow,0,1
syscpcrow   dw 0,206,0,0
syscpclst
dw 32768,0:ds 19*4


prgwingrpc db 25,0:dw prgwinobjc,0,0,0,0,0,27+1     ;*** CPC DISC AUSWAHL
prgwinobjc
dw     00,255*256+00,1         ,0,0,1000,1000,0     ;00=Hintergrund
dw     00,255*256+08,sprsyslog ,034, 08,252,13,0    ;01=Grafik Logo
dw     00,255*256+01,sysselobj5,004,172,208,08,0    ;02=Text Subtitel
dw     00,255*256+00,0         ,216,168, 32,14,0    ;03=Hintergund Help
dw     00,255*256+16,prgbutmsc1,217,169, 30,12,0    ;04=Button Help
dw     00,255*256+00,0         ,250,168, 33,14,0    ;05=Hintergund About
dw prginf,255*256+16,prgbutmsc2,251,169, 31,12,0    ;06=Button About
dw     00,255*256+00,0         ,285,168, 32,14,0    ;07=Hintergund Exit
dw syscpc,255*256+16,prgbutmsc4,286,169, 30,12,0    ;08=Button Exit
dw     00,255*256+01,sysselobj4,004,162,208,08,0    ;09=Text Anleitung

dw     00,255*256+01,sysselobj7,004, 30,312,08,0    ;10=Text Titel

dw     00,255*256+01,sysdskobj0,004, 39, 96,08,0    ;11=Config Titel
dw     00,255*256+01,sysselobjc,100, 39,216,08,0    ;12=Config Text

dw     00,255*256+01,sysdskobj1,004, 50,154,08,0    ;13=Text Drive A
dw     00,255*256+01,sysdskobj2,162, 50,154,08,0    ;14=Text Drive B
dw     00,255*256+00,2         ,004, 59,154,16,0    ;15=Hintergrund Pfad A
dw     00,255*256+00,2         ,162, 59,154,16,0    ;16=Hintergrund Pfad B
dw     00,255*256+32,sysdskobj3,006, 61,150,12,0    ;17=Input Pfad A
dw     00,255*256+32,sysdskobj4,164, 61,150,12,0    ;18=Input Pfad B
prgwinobj2
dw     00,255*256+02,1+4       ,082, 76, 78,12,0    ;19=Rahmen Passiv
dw     00,255*256+02,0+8       ,082, 76, 78,12,0    ;20=Rahmen Aktiv
dw dskfav0,255*256+1,sysdskobj5,006, 78, 74,08,0    ;21=Button "Favourites"
dw dskbra0,255*256+1,sysdskobj6,084, 78, 74,08,0    ;22=Button "Browse A"
dw dskbrb0,255*256+1,sysdskobj7,162, 78, 74,08,0    ;23=Button "Browse B"
dw dskrun,255*256+01,sysdskobj8,240, 78, 74,08,0    ;24=Button "Start"

dw     00,255*256+01,sysdskobja,004, 89,182,08,0    ;25=Favourites-Text
dw     00,255*256+02,2+8       ,004, 98,182,50,0    ;26=Favourites-Rahmen
prgwinobj3
dw ctldsk,255*256+64,sysdskobj9,005, 99,180,48,0    ;27=Favourites-Liste
dw     00,255*256+01,sysdskobjb,190, 89,126,08,0    ;28=Info-Text
dw     00,255*256+02,2+8       ,190, 98,126,50,0    ;29=Info-Rahmen

dw     00,255*256+01,sysdskdsc0+00,194,102,122,8,0  ;30=Text Information0
dw     00,255*256+01,sysdskdsc0+04,194,110,122,8,0  ;31=Text Information1
dw     00,255*256+01,sysdskdsc0+08,194,118,122,8,0  ;32=Text Information2
dw     00,255*256+01,sysdskdsc0+12,194,126,122,8,0  ;33=Text Information3
dw     00,255*256+01,sysdskdsc0+16,194,134,122,8,0  ;34=Text Information4

sysdskdsc0  dw 00,1+0,00,1+0,00,1+0,00,1+0,00,1+0

sysdskobj3  dw sysdskinp3,0,0,0,0,255,0
sysdskinp3a db "*  ",0
sysdskinp3  ds 256
sysdskobj4  dw sysdskinp4,0,0,0,0,255,0
sysdskinp4a db "*  ",0
sysdskinp4  ds 256

sysselobj7  dw sysseltxt7,3+0+512+128
sysdskobja  dw sysdsktxt5,3+0+512+128
sysdskobjb  dw syscpctxt3,3+0+512+128


sysdskobj0  dw sysdsktxt0,2+4+128
sysselobjc  dw 0,2+4+128

sysdskobj1  dw sysdsktxt1,3+0+512+128
sysdskobj2  dw sysdsktxt2,3+0+512+128
sysdskobj5  dw sysdsktxt5,2+4+512+128
sysdskobj6  dw sysdsktxt6,3+0+512+128
sysdskobj7  dw sysdsktxt7,2+4+512+128
sysdskobj8  dw sysdsktxt8,2+4+512+128

sysdskobj9  dw 5,0,sysdsklst,0,1,sysdskrow,0,1
sysdskrow   dw 0,206,0,0
sysdsklst
dw 32768,sysdsktxta:ds 49*4


prgwingrpd db 11,0:dw prgwinobjd,0,0,0,0,0,0        ;*** C64 DISC AUSWAHL
prgwinobjd
dw     00,255*256+00,1         ,0,0,1000,1000,0     ;00=Hintergrund
dw     00,255*256+08,sprsyslog ,034, 08,252,13,0    ;01=Grafik Logo
dw     00,255*256+01,sysselobj5,004,172,208,08,0    ;02=Text Subtitel
dw     00,255*256+00,0         ,216,168, 32,14,0    ;03=Hintergund Help
dw     00,255*256+16,prgbutmsc1,217,169, 30,12,0    ;04=Button Help
dw     00,255*256+00,0         ,250,168, 33,14,0    ;05=Hintergund About
dw prginf,255*256+16,prgbutmsc2,251,169, 31,12,0    ;06=Button About
dw     00,255*256+00,0         ,285,168, 32,14,0    ;07=Hintergund Exit
dw syscor,255*256+16,prgbutmsc4,286,169, 30,12,0    ;08=Button Exit
dw     00,255*256+01,sysselobj4,004,162,208,08,0    ;09=Text Anleitung
dw     00,255*256+01,sysselobj8,004, 30,312,08,0    ;10=Text Titel

sysselobj8  dw sysseltxt8,3+0+512+128


prgwingrpe db 11,0:dw prgwinobje,0,0,0,0,0,0        ;*** GAME AUSWAHL
prgwinobje
dw     00,255*256+00,1         ,0,0,1000,1000,0     ;00=Hintergrund
dw     00,255*256+08,sprsyslog ,034, 08,252,13,0    ;01=Grafik Logo
dw     00,255*256+01,sysselobj5,004,172,208,08,0    ;02=Text Subtitel
dw     00,255*256+00,0         ,216,168, 32,14,0    ;03=Hintergund Help
dw     00,255*256+16,prgbutmsc1,217,169, 30,12,0    ;04=Button Help
dw     00,255*256+00,0         ,250,168, 33,14,0    ;05=Hintergund About
dw prginf,255*256+16,prgbutmsc2,251,169, 31,12,0    ;06=Button About
dw     00,255*256+00,0         ,285,168, 32,14,0    ;07=Hintergund Exit
dw syscor,255*256+16,prgbutmsc4,286,169, 30,12,0    ;08=Button Exit
dw     00,255*256+01,sysselobj4,004,162,208,08,0    ;09=Text Anleitung
dw     00,255*256+01,sysselobj9,004, 30,312,08,0    ;10=Text Titel

sysselobj9  dw sysseltxt9,3+0+512+128


;### CPC RUN-FENSTER ##########################################################

prgarudat   dw #0001,20,19,79,280,70,0,0,280,70,280,70,280,70,prgicnsml,prgwintit,0,0,prgarugrp,0,0:ds 136+14
prgarugrp   db 9,0:dw prgaruobj,0,0,0,0,0,0
prgaruobj
dw     00,255*256+02,0+0+16+64,  000,00,280,70,0    ;00=Hintergrund
dw     00,255*256+01,sysarudsc1, 020,06,110,08,0    ;01=Text "Starting CPC..."/"Writing back..."
prgaruobj1
dw     00,255*256+01,sysarudsc2, 020,21,110,08,0    ;02=Text "Rom configuration"
dw     00,255*256+01,sysarudsc3, 020,37,110,08,0    ;03=Text "Disc Drive A"
dw     00,255*256+01,sysarudsc4, 020,53,110,08,0    ;04=Text "Disc Drive B"
prgaruobj0
dw     00,255*256+04,256*000+202,100,19,160,12,0    ;05=Progress "Rom configuration"
dw     00,255*256+04,256*000+202,100,35,160,12,0    ;06=Progress "Disc Drive A"
dw     00,255*256+04,256*000+202,100,51,160,12,0    ;07=Progress "Disc Drive B"
dw     00,255*256+01,sysarudsc5 ,100,06,176,08,0    ;08=Text File

sysarudsc1  dw sysarutxt1,1+0
sysarudsc2  dw sysarutxt2,1+8
sysarudsc3  dw sysarutxt3,1+8
sysarudsc4  dw sysarutxt4,1+8
sysarudsc5  dw sysarutxt0,1+0+128


prgtrnend

relocate_table
relocate_end
